package scripts;

import com.stencyl.graphics.G;
import com.stencyl.graphics.BitmapWrapper;

import com.stencyl.behavior.Script;
import com.stencyl.behavior.Script.*;
import com.stencyl.behavior.ActorScript;
import com.stencyl.behavior.SceneScript;
import com.stencyl.behavior.TimedTask;

import com.stencyl.models.Actor;
import com.stencyl.models.GameModel;
import com.stencyl.models.actor.Animation;
import com.stencyl.models.actor.ActorType;
import com.stencyl.models.actor.Collision;
import com.stencyl.models.actor.Group;
import com.stencyl.models.Scene;
import com.stencyl.models.Sound;
import com.stencyl.models.Region;
import com.stencyl.models.Font;
import com.stencyl.models.Joystick;

import com.stencyl.Engine;
import com.stencyl.Input;
import com.stencyl.Key;
import com.stencyl.utils.Utils;

import openfl.ui.Mouse;
import openfl.display.Graphics;
import openfl.display.BlendMode;
import openfl.display.BitmapData;
import openfl.display.Bitmap;
import openfl.events.Event;
import openfl.events.KeyboardEvent;
import openfl.events.TouchEvent;
import openfl.net.URLLoader;

import box2D.common.math.B2Vec2;
import box2D.dynamics.B2Body;
import box2D.dynamics.B2Fixture;
import box2D.dynamics.joints.B2Joint;

import motion.Actuate;
import motion.easing.Back;
import motion.easing.Cubic;
import motion.easing.Elastic;
import motion.easing.Expo;
import motion.easing.Linear;
import motion.easing.Quad;
import motion.easing.Quart;
import motion.easing.Quint;
import motion.easing.Sine;

import com.stencyl.graphics.shaders.BasicShader;
import com.stencyl.graphics.shaders.GrayscaleShader;
import com.stencyl.graphics.shaders.SepiaShader;
import com.stencyl.graphics.shaders.InvertShader;
import com.stencyl.graphics.shaders.GrainShader;
import com.stencyl.graphics.shaders.ExternalShader;
import com.stencyl.graphics.shaders.InlineShader;
import com.stencyl.graphics.shaders.BlurShader;
import com.stencyl.graphics.shaders.SharpenShader;
import com.stencyl.graphics.shaders.ScanlineShader;
import com.stencyl.graphics.shaders.CSBShader;
import com.stencyl.graphics.shaders.HueShader;
import com.stencyl.graphics.shaders.TintShader;
import com.stencyl.graphics.shaders.BloomShader;



class ActorEvents_102 extends ActorScript
{
	public var _Fade:Bool;
	
	
	public function new(dummy:Int, actor:Actor, dummy2:Engine)
	{
		super(actor);
		nameMap.set("Fade", "_Fade");
		_Fade = false;
		
	}
	
	override public function init()
	{
		
		/* ======================== When Creating ========================= */
		actor.fadeTo(0 / 100, 0, Linear.easeNone);
		actor.fadeTo(100 / 100, 0.75, Linear.easeNone);
		actor.moveBy(0, -8, 1, Quad.easeOut);
		runLater(1000 * 3, function(timeTask:TimedTask):Void
		{
			runPeriodically(1000 * 0.1, function(timeTask:TimedTask):Void
			{
				for(actorInGroup in cast(getActorGroup(0), Group).list)
				{
					if(actorInGroup != null && !actorInGroup.dead && !actorInGroup.recycled){
						if((actorInGroup.getAnimation() == "Run"))
						{
							if(!(_Fade))
							{
								_Fade = true;
								for(actorOfType in getActorsOfType(getActorType(122)))
								{
									if(actorOfType != null && !actorOfType.dead && !actorOfType.recycled){
										actorOfType.shout("_customEvent_" + "Kill");
									}
								}
								for(actorOfType in getActorsOfType(getActorType(124)))
								{
									if(actorOfType != null && !actorOfType.dead && !actorOfType.recycled){
										actorOfType.shout("_customEvent_" + "Kill");
									}
								}
								runLater(1000 * 1, function(timeTask:TimedTask):Void
								{
									actor.fadeTo(0 / 100, 2.5, Linear.easeNone);
									runLater(1000 * 2.5, function(timeTask:TimedTask):Void
									{
										recycleActor(actor);
									}, actor);
								}, actor);
							}
						}
					}
				}
			}, actor);
		}, actor);
		runPeriodically(1000 * 2, function(timeTask:TimedTask):Void
		{
			actor.moveBy(0, 2, 1, Quad.easeInOut);
			runLater(1000 * 1, function(timeTask:TimedTask):Void
			{
				actor.moveBy(0, -2, 1, Quad.easeInOut);
			}, actor);
		}, actor);
		
	}
	
	override public function forwardMessage(msg:String)
	{
		
	}
}