package scripts;

import com.stencyl.graphics.G;
import com.stencyl.graphics.BitmapWrapper;

import com.stencyl.behavior.Script;
import com.stencyl.behavior.Script.*;
import com.stencyl.behavior.ActorScript;
import com.stencyl.behavior.SceneScript;
import com.stencyl.behavior.TimedTask;

import com.stencyl.models.Actor;
import com.stencyl.models.GameModel;
import com.stencyl.models.actor.Animation;
import com.stencyl.models.actor.ActorType;
import com.stencyl.models.actor.Collision;
import com.stencyl.models.actor.Group;
import com.stencyl.models.Scene;
import com.stencyl.models.Sound;
import com.stencyl.models.Region;
import com.stencyl.models.Font;
import com.stencyl.models.Joystick;

import com.stencyl.Engine;
import com.stencyl.Input;
import com.stencyl.Key;
import com.stencyl.utils.Utils;

import openfl.ui.Mouse;
import openfl.display.Graphics;
import openfl.display.BlendMode;
import openfl.display.BitmapData;
import openfl.display.Bitmap;
import openfl.events.Event;
import openfl.events.KeyboardEvent;
import openfl.events.TouchEvent;
import openfl.net.URLLoader;

import box2D.common.math.B2Vec2;
import box2D.dynamics.B2Body;
import box2D.dynamics.B2Fixture;
import box2D.dynamics.joints.B2Joint;

import motion.Actuate;
import motion.easing.Back;
import motion.easing.Cubic;
import motion.easing.Elastic;
import motion.easing.Expo;
import motion.easing.Linear;
import motion.easing.Quad;
import motion.easing.Quart;
import motion.easing.Quint;
import motion.easing.Sine;

import com.stencyl.graphics.shaders.BasicShader;
import com.stencyl.graphics.shaders.GrayscaleShader;
import com.stencyl.graphics.shaders.SepiaShader;
import com.stencyl.graphics.shaders.InvertShader;
import com.stencyl.graphics.shaders.GrainShader;
import com.stencyl.graphics.shaders.ExternalShader;
import com.stencyl.graphics.shaders.InlineShader;
import com.stencyl.graphics.shaders.BlurShader;
import com.stencyl.graphics.shaders.SharpenShader;
import com.stencyl.graphics.shaders.ScanlineShader;
import com.stencyl.graphics.shaders.CSBShader;
import com.stencyl.graphics.shaders.HueShader;
import com.stencyl.graphics.shaders.TintShader;
import com.stencyl.graphics.shaders.BloomShader;



class ActorEvents_168 extends ActorScript
{
	
	
	public function new(dummy:Int, actor:Actor, dummy2:Engine)
	{
		super(actor);
		
	}
	
	override public function init()
	{
		
		/* ======================== When Creating ========================= */
		actor.growTo(0/100, 0/100, 0, Linear.easeNone);
		runLater(1000 * 0.1, function(timeTask:TimedTask):Void
		{
			/* "" */ if(!((Engine.engine.getGameAttribute("MuteSound") : Bool)))
			{
				playSound(getSound(138));
			}
			for(index0 in 0...3)
			{
				createRecycledActor(getActorType(11), ((actor.getXCenter() - 1) + randomInt(-20, 20)), ((actor.getYCenter() - 1) + randomInt(-16, 16)), Script.FRONT);
			}
			runLater(1000 * 0.1, function(timeTask:TimedTask):Void
			{
				for(index0 in 0...3)
				{
					createRecycledActor(getActorType(11), ((actor.getXCenter() - 1) + randomInt(-20, 20)), ((actor.getYCenter() - 1) + randomInt(-16, 16)), Script.FRONT);
				}
				runLater(1000 * 0.1, function(timeTask:TimedTask):Void
				{
					for(index0 in 0...2)
					{
						createRecycledActor(getActorType(11), ((actor.getXCenter() - 1) + randomInt(-20, 20)), ((actor.getYCenter() - 1) + randomInt(-16, 16)), Script.FRONT);
					}
				}, actor);
			}, actor);
			actor.growTo(50/100, 270/100, 0.05, Expo.easeInOut);
			runLater(1000 * 0.06, function(timeTask:TimedTask):Void
			{
				actor.growTo(175/100, 30/100, 0.05, Expo.easeInOut);
				runLater(1000 * 0.06, function(timeTask:TimedTask):Void
				{
					actor.growTo(100/100, 100/100, 0.2, Elastic.easeOut);
				}, actor);
			}, actor);
		}, actor);
		
	}
	
	override public function forwardMessage(msg:String)
	{
		
	}
}