package scripts;

import com.stencyl.graphics.G;
import com.stencyl.graphics.BitmapWrapper;

import com.stencyl.behavior.Script;
import com.stencyl.behavior.Script.*;
import com.stencyl.behavior.ActorScript;
import com.stencyl.behavior.SceneScript;
import com.stencyl.behavior.TimedTask;

import com.stencyl.models.Actor;
import com.stencyl.models.GameModel;
import com.stencyl.models.actor.Animation;
import com.stencyl.models.actor.ActorType;
import com.stencyl.models.actor.Collision;
import com.stencyl.models.actor.Group;
import com.stencyl.models.Scene;
import com.stencyl.models.Sound;
import com.stencyl.models.Region;
import com.stencyl.models.Font;
import com.stencyl.models.Joystick;

import com.stencyl.Engine;
import com.stencyl.Input;
import com.stencyl.Key;
import com.stencyl.utils.Utils;

import openfl.ui.Mouse;
import openfl.display.Graphics;
import openfl.display.BlendMode;
import openfl.display.BitmapData;
import openfl.display.Bitmap;
import openfl.events.Event;
import openfl.events.KeyboardEvent;
import openfl.events.TouchEvent;
import openfl.net.URLLoader;

import box2D.common.math.B2Vec2;
import box2D.dynamics.B2Body;
import box2D.dynamics.B2Fixture;
import box2D.dynamics.joints.B2Joint;

import motion.Actuate;
import motion.easing.Back;
import motion.easing.Cubic;
import motion.easing.Elastic;
import motion.easing.Expo;
import motion.easing.Linear;
import motion.easing.Quad;
import motion.easing.Quart;
import motion.easing.Quint;
import motion.easing.Sine;

import com.stencyl.graphics.shaders.BasicShader;
import com.stencyl.graphics.shaders.GrayscaleShader;
import com.stencyl.graphics.shaders.SepiaShader;
import com.stencyl.graphics.shaders.InvertShader;
import com.stencyl.graphics.shaders.GrainShader;
import com.stencyl.graphics.shaders.ExternalShader;
import com.stencyl.graphics.shaders.InlineShader;
import com.stencyl.graphics.shaders.BlurShader;
import com.stencyl.graphics.shaders.SharpenShader;
import com.stencyl.graphics.shaders.ScanlineShader;
import com.stencyl.graphics.shaders.CSBShader;
import com.stencyl.graphics.shaders.HueShader;
import com.stencyl.graphics.shaders.TintShader;
import com.stencyl.graphics.shaders.BloomShader;



class ActorEvents_72 extends ActorScript
{
	public var _Touching:Float;
	public var _Touch:Bool;
	public var _Warp:Bool;
	public var _SpawnedS:Bool;
	public var _StorePressActor:Actor;
	
	
	public function new(dummy:Int, actor:Actor, dummy2:Engine)
	{
		super(actor);
		nameMap.set("Touching?", "_Touching");
		_Touching = 0.0;
		nameMap.set("Touch", "_Touch");
		_Touch = false;
		nameMap.set("Warp?", "_Warp");
		_Warp = false;
		nameMap.set("SpawnedS", "_SpawnedS");
		_SpawnedS = false;
		nameMap.set("StorePressActor", "_StorePressActor");
		
	}
	
	override public function init()
	{
		
		/* ======================== When Creating ========================= */
		_Touching = 1000;
		_Touch = false;
		
		/* ======================== When Updating ========================= */
		addWhenUpdatedListener(null, function(elapsedTime:Float, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled)
			{
				/* "" */ _Touching = (_Touching + 1);
				if((_Touching >= 10))
				{
					_Touch = false;
					if(_SpawnedS)
					{
						_SpawnedS = false;
						if((hasValue(_StorePressActor)))
						{
							if(_StorePressActor.isAlive())
							{
								recycleActor(_StorePressActor);
							}
						}
					}
				}
				else
				{
					_Touch = true;
					if(!(_SpawnedS))
					{
						_SpawnedS = true;
						createRecycledActor(getActorType(80), (actor.getXCenter() - 6), (actor.getY() - 22), Script.FRONT);
						_StorePressActor = getLastCreatedActor();
					}
				}
				if(_Touch)
				{
					if(isKeyDown("Attack"))
					{
						if(!(_Warp))
						{
							_Warp = true;
							/* "" */ if((hasValue(_StorePressActor)))
							{
								if(_StorePressActor.isAlive())
								{
									recycleActor(_StorePressActor);
								}
							}
							for(actorOfType in getActorsOfType(getActorType(5)))
							{
								if(actorOfType != null && !actorOfType.dead && !actorOfType.recycled){
									recycleActor(actorOfType);
								}
							}
							for(actorOfType in getActorsOfType(getActorType(2)))
							{
								if(actorOfType != null && !actorOfType.dead && !actorOfType.recycled){
									recycleActor(actorOfType);
								}
							}
							for(actorOfType in getActorsOfType(getActorType(7)))
							{
								if(actorOfType != null && !actorOfType.dead && !actorOfType.recycled){
									recycleActor(actorOfType);
								}
							}
							for(actorOfType in getActorsOfType(getActorType(0)))
							{
								if(actorOfType != null && !actorOfType.dead && !actorOfType.recycled){
									recycleActor(actorOfType);
								}
							}
							createRecycledActor(getActorType(70), (actor.getXCenter() - 8), (actor.getY() - 50), Script.FRONT);
							createRecycledActor(getActorType(74), ((getScreenWidth() / 2) - 36), 30, Script.FRONT);
							Engine.engine.setGameAttribute("FirstSpawn", true);
							/* "" */ /* Save */
							for(item in ((Engine.engine.getGameAttribute("Inventory") : Map<String,Dynamic>) : Map<String,Dynamic>).keys())
							{
								(Engine.engine.getGameAttribute("Inventory") : Map<String,Dynamic>).set("" + item, (asNumber((Engine.engine.getGameAttribute("InventoryTemp") : Map<String,Dynamic>).get("" + item)) + asNumber((Engine.engine.getGameAttribute("Inventory") : Map<String,Dynamic>).get("" + item))));
							}
							/* Reset */
							for(item in ((Engine.engine.getGameAttribute("InventoryTemp") : Map<String,Dynamic>) : Map<String,Dynamic>).keys())
							{
								(Engine.engine.getGameAttribute("InventoryTemp") : Map<String,Dynamic>).set("" + item, 0);
							}
							runLater(1000 * 0.5, function(timeTask:TimedTask):Void
							{
								saveGame("mySave", function(success:Bool):Void
								{
									
								});
								switchScene(GameModel.get().scenes.get(1).getID(), createFadeOut(1, Utils.getColorRGB(0,0,0)), createFadeIn(1, Utils.getColorRGB(0,0,0)));
							}, actor);
						}
					}
				}
			}
		});
		
		/* ======================= Member of Group ======================== */
		addCollisionListener(actor, function(event:Collision, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled && sameAsAny(getActorGroup(0),event.otherActor.getType(),event.otherActor.getGroup()))
			{
				_Touch = true;
				_Touching = 0;
			}
		});
		
	}
	
	override public function forwardMessage(msg:String)
	{
		
	}
}