package scripts;

import com.stencyl.graphics.G;
import com.stencyl.graphics.BitmapWrapper;

import com.stencyl.behavior.Script;
import com.stencyl.behavior.Script.*;
import com.stencyl.behavior.ActorScript;
import com.stencyl.behavior.SceneScript;
import com.stencyl.behavior.TimedTask;

import com.stencyl.models.Actor;
import com.stencyl.models.GameModel;
import com.stencyl.models.actor.Animation;
import com.stencyl.models.actor.ActorType;
import com.stencyl.models.actor.Collision;
import com.stencyl.models.actor.Group;
import com.stencyl.models.Scene;
import com.stencyl.models.Sound;
import com.stencyl.models.Region;
import com.stencyl.models.Font;
import com.stencyl.models.Joystick;

import com.stencyl.Engine;
import com.stencyl.Input;
import com.stencyl.Key;
import com.stencyl.utils.Utils;

import openfl.ui.Mouse;
import openfl.display.Graphics;
import openfl.display.BlendMode;
import openfl.display.BitmapData;
import openfl.display.Bitmap;
import openfl.events.Event;
import openfl.events.KeyboardEvent;
import openfl.events.TouchEvent;
import openfl.net.URLLoader;

import box2D.common.math.B2Vec2;
import box2D.dynamics.B2Body;
import box2D.dynamics.B2Fixture;
import box2D.dynamics.joints.B2Joint;

import motion.Actuate;
import motion.easing.Back;
import motion.easing.Cubic;
import motion.easing.Elastic;
import motion.easing.Expo;
import motion.easing.Linear;
import motion.easing.Quad;
import motion.easing.Quart;
import motion.easing.Quint;
import motion.easing.Sine;

import com.stencyl.graphics.shaders.BasicShader;
import com.stencyl.graphics.shaders.GrayscaleShader;
import com.stencyl.graphics.shaders.SepiaShader;
import com.stencyl.graphics.shaders.InvertShader;
import com.stencyl.graphics.shaders.GrainShader;
import com.stencyl.graphics.shaders.ExternalShader;
import com.stencyl.graphics.shaders.InlineShader;
import com.stencyl.graphics.shaders.BlurShader;
import com.stencyl.graphics.shaders.SharpenShader;
import com.stencyl.graphics.shaders.ScanlineShader;
import com.stencyl.graphics.shaders.CSBShader;
import com.stencyl.graphics.shaders.HueShader;
import com.stencyl.graphics.shaders.TintShader;
import com.stencyl.graphics.shaders.BloomShader;



class ActorEvents_78 extends ActorScript
{
	public var _WhichItem:String;
	public var _WhichStoreSpace:Float;
	
	
	public function new(dummy:Int, actor:Actor, dummy2:Engine)
	{
		super(actor);
		nameMap.set("WhichItem", "_WhichItem");
		_WhichItem = "None";
		nameMap.set("WhichStoreSpace?", "_WhichStoreSpace");
		_WhichStoreSpace = 1.0;
		
	}
	
	override public function init()
	{
		
		/* ======================== When Creating ========================= */
		actor.disableActorDrawing();
		actor.moveToLayer(engine.getLayerByName("Player"));
		
		/* ======================== When Updating ========================= */
		addWhenUpdatedListener(null, function(elapsedTime:Float, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled)
			{
				if(actor.isMousePressed())
				{
					if((Engine.engine.getGameAttribute("UsingPersonalStore") : Bool))
					{
						if((asNumber((Engine.engine.getGameAttribute("Inventory") : Map<String,Dynamic>).get(_WhichItem)) >= 1))
						{
							Engine.engine.setGameAttribute("UsingPersonalStore", false);
							/* "" */ for(actorOfType in getActorsOfType(getActorType(76)))
							{
								if(actorOfType != null && !actorOfType.dead && !actorOfType.recycled){
									if((_WhichStoreSpace == 1))
									{
										Engine.engine.setGameAttribute("StoreItem1", _WhichItem);
									}
									else if((_WhichStoreSpace == 2))
									{
										Engine.engine.setGameAttribute("StoreItem2", _WhichItem);
									}
									else if((_WhichStoreSpace == 3))
									{
										Engine.engine.setGameAttribute("StoreItem3", _WhichItem);
									}
									else if((_WhichStoreSpace == 4))
									{
										Engine.engine.setGameAttribute("StoreItem4", _WhichItem);
									}
									if((actorOfType.getValue("StoreItem_", "_WhichStoreItem") == _WhichStoreSpace))
									{
										actorOfType.setAnimation("On");
										actorOfType.setValue("StoreItem_", "_CurrentStoreItem", _WhichItem);
									}
								}
							}
							for(actorInGroup in cast(getActorGroup(0), Group).list)
							{
								if(actorInGroup != null && !actorInGroup.dead && !actorInGroup.recycled){
									actorInGroup.setActorValue("UsingStore?", false);
								}
							}
							for(actorOfType in getActorsOfType(getActorType(84)))
							{
								if(actorOfType != null && !actorOfType.dead && !actorOfType.recycled){
									recycleActor(actorOfType);
								}
							}
							for(actorOfType in getActorsOfType(getActorType(78)))
							{
								if(actorOfType != null && !actorOfType.dead && !actorOfType.recycled){
									recycleActor(actorOfType);
								}
							}
							for(actorOfType in getActorsOfType(getActorType(82)))
							{
								if(actorOfType != null && !actorOfType.dead && !actorOfType.recycled){
									recycleActor(actorOfType);
								}
							}
							recycleActor(actor);
						}
					}
				}
			}
		});
		
		/* ========================= When Drawing ========================= */
		addWhenDrawingListener(null, function(g:G, x:Float, y:Float, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled)
			{
				Script.setDrawingLayerToSceneLayer();
				actor.drawImage(g);
				g.translateToScreen();
				g.setFont(getFont(51));
				if((asNumber((Engine.engine.getGameAttribute("Inventory") : Map<String,Dynamic>).get(_WhichItem)) >= 1))
				{
					g.alpha = (100/100);
					DrawText.drawText(g, ("" + _WhichItem), "c", actor.getXCenter(), (actor.getYCenter() + -10));
					DrawText.drawText(g, ("" + (Engine.engine.getGameAttribute("Inventory") : Map<String,Dynamic>).get(_WhichItem)), "c", actor.getXCenter(), (actor.getYCenter() + -2));
				}
				else
				{
					g.alpha = (50/100);
					DrawText.drawText(g, "None", "c", actor.getXCenter(), (actor.getYCenter() + -5));
				}
			}
		});
		
	}
	
	override public function forwardMessage(msg:String)
	{
		
	}
}