package scripts;

import com.stencyl.graphics.G;
import com.stencyl.graphics.BitmapWrapper;

import com.stencyl.behavior.Script;
import com.stencyl.behavior.Script.*;
import com.stencyl.behavior.ActorScript;
import com.stencyl.behavior.SceneScript;
import com.stencyl.behavior.TimedTask;

import com.stencyl.models.Actor;
import com.stencyl.models.GameModel;
import com.stencyl.models.actor.Animation;
import com.stencyl.models.actor.ActorType;
import com.stencyl.models.actor.Collision;
import com.stencyl.models.actor.Group;
import com.stencyl.models.Scene;
import com.stencyl.models.Sound;
import com.stencyl.models.Region;
import com.stencyl.models.Font;
import com.stencyl.models.Joystick;

import com.stencyl.Engine;
import com.stencyl.Input;
import com.stencyl.Key;
import com.stencyl.utils.Utils;

import openfl.ui.Mouse;
import openfl.display.Graphics;
import openfl.display.BlendMode;
import openfl.display.BitmapData;
import openfl.display.Bitmap;
import openfl.events.Event;
import openfl.events.KeyboardEvent;
import openfl.events.TouchEvent;
import openfl.net.URLLoader;

import box2D.common.math.B2Vec2;
import box2D.dynamics.B2Body;
import box2D.dynamics.B2Fixture;
import box2D.dynamics.joints.B2Joint;

import motion.Actuate;
import motion.easing.Back;
import motion.easing.Cubic;
import motion.easing.Elastic;
import motion.easing.Expo;
import motion.easing.Linear;
import motion.easing.Quad;
import motion.easing.Quart;
import motion.easing.Quint;
import motion.easing.Sine;

import com.stencyl.graphics.shaders.BasicShader;
import com.stencyl.graphics.shaders.GrayscaleShader;
import com.stencyl.graphics.shaders.SepiaShader;
import com.stencyl.graphics.shaders.InvertShader;
import com.stencyl.graphics.shaders.GrainShader;
import com.stencyl.graphics.shaders.ExternalShader;
import com.stencyl.graphics.shaders.InlineShader;
import com.stencyl.graphics.shaders.BlurShader;
import com.stencyl.graphics.shaders.SharpenShader;
import com.stencyl.graphics.shaders.ScanlineShader;
import com.stencyl.graphics.shaders.CSBShader;
import com.stencyl.graphics.shaders.HueShader;
import com.stencyl.graphics.shaders.TintShader;
import com.stencyl.graphics.shaders.BloomShader;



class ActorEvents_92 extends ActorScript
{
	public var _WhichWeapon:String;
	public var _Cost:Float;
	
	
	public function new(dummy:Int, actor:Actor, dummy2:Engine)
	{
		super(actor);
		nameMap.set("WhichWeapon?", "_WhichWeapon");
		_WhichWeapon = "";
		nameMap.set("Cost", "_Cost");
		_Cost = 0.0;
		
	}
	
	override public function init()
	{
		
		/* ======================== When Creating ========================= */
		actor.disableActorDrawing();
		actor.moveToLayer(engine.getLayerByName("Player"));
		
		/* ========================= When Drawing ========================= */
		addWhenDrawingListener(null, function(g:G, x:Float, y:Float, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled)
			{
				Script.setDrawingLayerToSceneLayer();
				if((asNumber((Engine.engine.getGameAttribute("Swords") : Map<String,Dynamic>).get(_WhichWeapon)) >= 1))
				{
					g.alpha = (100/100);
				}
				else
				{
					if(((Engine.engine.getGameAttribute("Souls") : Float) >= _Cost))
					{
						g.alpha = (100/100);
					}
					else
					{
						g.alpha = (50/100);
					}
				}
				actor.drawImage(g);
				g.translateToScreen();
				g.setFont(getFont(51));
				/* "" */ if((_WhichWeapon == "Heart"))
				{
					if(((Engine.engine.getGameAttribute("Hearts") : Float) >= 3))
					{
						g.alpha = (50/100);
					}
				}
				DrawText.drawText(g, _WhichWeapon, "l", (actor.getX() + 6), (actor.getY() + 4));
				if((asNumber((Engine.engine.getGameAttribute("Swords") : Map<String,Dynamic>).get(_WhichWeapon)) >= 1))
				{
					DrawText.drawText(g, "Owned", "l", (actor.getX() + 13), (actor.getY() + 14));
				}
				else
				{
					DrawText.drawText(g, _Cost, "l", (actor.getX() + 13), (actor.getY() + 14));
				}
			}
		});
		
	}
	
	override public function forwardMessage(msg:String)
	{
		
	}
}