package scripts;

import com.stencyl.graphics.G;
import com.stencyl.graphics.BitmapWrapper;

import com.stencyl.behavior.Script;
import com.stencyl.behavior.Script.*;
import com.stencyl.behavior.ActorScript;
import com.stencyl.behavior.SceneScript;
import com.stencyl.behavior.TimedTask;

import com.stencyl.models.Actor;
import com.stencyl.models.GameModel;
import com.stencyl.models.actor.Animation;
import com.stencyl.models.actor.ActorType;
import com.stencyl.models.actor.Collision;
import com.stencyl.models.actor.Group;
import com.stencyl.models.Scene;
import com.stencyl.models.Sound;
import com.stencyl.models.Region;
import com.stencyl.models.Font;
import com.stencyl.models.Joystick;

import com.stencyl.Engine;
import com.stencyl.Input;
import com.stencyl.Key;
import com.stencyl.utils.Utils;

import openfl.ui.Mouse;
import openfl.display.Graphics;
import openfl.display.BlendMode;
import openfl.display.BitmapData;
import openfl.display.Bitmap;
import openfl.events.Event;
import openfl.events.KeyboardEvent;
import openfl.events.TouchEvent;
import openfl.net.URLLoader;

import box2D.common.math.B2Vec2;
import box2D.dynamics.B2Body;
import box2D.dynamics.B2Fixture;
import box2D.dynamics.joints.B2Joint;

import motion.Actuate;
import motion.easing.Back;
import motion.easing.Cubic;
import motion.easing.Elastic;
import motion.easing.Expo;
import motion.easing.Linear;
import motion.easing.Quad;
import motion.easing.Quart;
import motion.easing.Quint;
import motion.easing.Sine;

import com.stencyl.graphics.shaders.BasicShader;
import com.stencyl.graphics.shaders.GrayscaleShader;
import com.stencyl.graphics.shaders.SepiaShader;
import com.stencyl.graphics.shaders.InvertShader;
import com.stencyl.graphics.shaders.GrainShader;
import com.stencyl.graphics.shaders.ExternalShader;
import com.stencyl.graphics.shaders.InlineShader;
import com.stencyl.graphics.shaders.BlurShader;
import com.stencyl.graphics.shaders.SharpenShader;
import com.stencyl.graphics.shaders.ScanlineShader;
import com.stencyl.graphics.shaders.CSBShader;
import com.stencyl.graphics.shaders.HueShader;
import com.stencyl.graphics.shaders.TintShader;
import com.stencyl.graphics.shaders.BloomShader;



class Design_11_11_Particles1 extends ActorScript
{
	public var _RandRNG1:Float;
	public var _DecelerationSpeedWhenmoving:Float;
	public var _EnableDecelerationSpeed:Bool;
	public var _StartSpeedMin:Float;
	public var _StartSpeedMax:Float;
	public var _MaxStartAnimatingAfterRNG:Float;
	public var _RNGFrameTimeCheck:Float;
	public var _DoAReverseDecelerationInstead:Bool;
	public var _ReverseDecelSpeed:Float;
	public var _Angle:Float;
	public var _Speed:Float;
	public var _DontChangeAngle:Bool;
	public var _DisappearEffectNumber:Float;
	public var _KillAfterRandomNumberMin:Float;
	public var _KillAfterRandomNumberMax:Float;
	public var _KillOnAnimationEnd:Bool;
	public var _Rotate:Bool;
	public var _RandRotateSpeedMin:Float;
	public var _RandRotateSpeedMax:Float;
	public var _GrowSelfDownAndKill:Bool;
	public var _GrowTime:Float;
	public var _CustomAngle:Bool;
	public var _CustomAngle1:Float;
	public var _CustomAngle2:Float;
	
	/* ========================= Custom Event ========================= */
	public function _customEvent_BlinkOut():Void
	{
		actor.disableActorDrawing();
		runLater(1000 * 0.05, function(timeTask:TimedTask):Void
		{
			actor.enableActorDrawing();
			actor.fadeTo(75 / 100, 0, Linear.easeNone);
			runLater(1000 * 0.05, function(timeTask:TimedTask):Void
			{
				actor.disableActorDrawing();
				runLater(1000 * 0.05, function(timeTask:TimedTask):Void
				{
					actor.enableActorDrawing();
					actor.fadeTo(50 / 100, 0, Linear.easeNone);
					runLater(1000 * 0.05, function(timeTask:TimedTask):Void
					{
						recycleActor(actor);
					}, actor);
				}, actor);
			}, actor);
		}, actor);
	}
	
	
	public function new(dummy:Int, actor:Actor, dummy2:Engine)
	{
		super(actor);
		nameMap.set("Actor", "actor");
		nameMap.set("Rand_RNG1", "_RandRNG1");
		_RandRNG1 = 0.0;
		nameMap.set("Deceleration Speed When moving?", "_DecelerationSpeedWhenmoving");
		_DecelerationSpeedWhenmoving = 0.07;
		nameMap.set("Enable Deceleration Speed?", "_EnableDecelerationSpeed");
		_EnableDecelerationSpeed = false;
		nameMap.set("Start Speed_Min", "_StartSpeedMin");
		_StartSpeedMin = 0.0;
		nameMap.set("Start Speed_Max", "_StartSpeedMax");
		_StartSpeedMax = 5.0;
		nameMap.set("Max_StartAnimatingAfter? RNG", "_MaxStartAnimatingAfterRNG");
		_MaxStartAnimatingAfterRNG = 0.0;
		nameMap.set("RNG_FrameTimeCheck", "_RNGFrameTimeCheck");
		_RNGFrameTimeCheck = 25.0;
		nameMap.set("Do A Reverse Deceleration Instead?", "_DoAReverseDecelerationInstead");
		_DoAReverseDecelerationInstead = false;
		nameMap.set("Reverse Decel Speed?", "_ReverseDecelSpeed");
		_ReverseDecelSpeed = 1.0;
		nameMap.set("Angle?", "_Angle");
		_Angle = 0.0;
		nameMap.set("Speed?", "_Speed");
		_Speed = 0.0;
		nameMap.set("Dont Change Angle?", "_DontChangeAngle");
		_DontChangeAngle = false;
		nameMap.set("Disappear Effect Number", "_DisappearEffectNumber");
		_DisappearEffectNumber = 0.0;
		nameMap.set("KillAfterRandomNumberMin", "_KillAfterRandomNumberMin");
		_KillAfterRandomNumberMin = 2.0;
		nameMap.set("KillAfterRandomNumberMax", "_KillAfterRandomNumberMax");
		_KillAfterRandomNumberMax = 3.0;
		nameMap.set("KillOnAnimationEnd?", "_KillOnAnimationEnd");
		_KillOnAnimationEnd = false;
		nameMap.set("Rotate?", "_Rotate");
		_Rotate = false;
		nameMap.set("RandRotateSpeedMin", "_RandRotateSpeedMin");
		_RandRotateSpeedMin = 20.0;
		nameMap.set("RandRotateSpeedMax", "_RandRotateSpeedMax");
		_RandRotateSpeedMax = 40.0;
		nameMap.set("GrowSelfDownAndKill?", "_GrowSelfDownAndKill");
		_GrowSelfDownAndKill = false;
		nameMap.set("GrowTime", "_GrowTime");
		_GrowTime = 0.5;
		nameMap.set("CustomAngle?", "_CustomAngle");
		_CustomAngle = false;
		nameMap.set("Custom Angle 1", "_CustomAngle1");
		_CustomAngle1 = 0.0;
		nameMap.set("Custom Angle 2", "_CustomAngle2");
		_CustomAngle2 = 0.0;
		
	}
	
	override public function init()
	{
		
		/* ======================== When Creating ========================= */
		actor.makeAlwaysSimulate();
		if(_Rotate)
		{
			if((randomInt(0, 1) == 1))
			{
				actor.setAngularVelocity(Utils.RAD * (randomInt(Std.int(_RandRotateSpeedMin), Std.int(_RandRotateSpeedMax))));
			}
			else
			{
				actor.setAngularVelocity(Utils.RAD * (-(randomInt(Std.int(_RandRotateSpeedMin), Std.int(_RandRotateSpeedMax)))));
			}
		}
		/* "Random Point self" */ _RandRNG1 = randomInt(0, 3);
		if(!(_DontChangeAngle))
		{
			actor.setAngle(Utils.RAD * ((0 + (90 * _RandRNG1))));
		}
		/* "Random Angle(360) or custom random angle." */ if(_CustomAngle)
		{
			_Angle = randomInt(Std.int(_CustomAngle1), Std.int(_CustomAngle2));
		}
		else
		{
			_Angle = randomInt(0, 360);
		}
		_Speed = randomInt(Std.int(_StartSpeedMin), Std.int(_StartSpeedMax));
		actor.setVelocity(_Angle, _Speed);
		if(!(_DoAReverseDecelerationInstead))
		{
			if(_EnableDecelerationSpeed)
			{
				runPeriodically(1000 * 0.05, function(timeTask:TimedTask):Void
				{
					actor.setXVelocity((actor.getXVelocity() * _DecelerationSpeedWhenmoving));
					actor.setYVelocity((actor.getYVelocity() * _DecelerationSpeedWhenmoving));
				}, actor);
			}
		}
		else
		{
			runPeriodically(1000 * 0.1, function(timeTask:TimedTask):Void
			{
				_Speed = (_Speed - _ReverseDecelSpeed);
				actor.setVelocity(_Angle, _Speed);
			}, actor);
		}
		/* "" */ if((!(_KillOnAnimationEnd) && !(_GrowSelfDownAndKill)))
		{
			runLater(1000 * (randomInt(0, 400) / 1000), function(timeTask:TimedTask):Void
			{
				runLater(1000 * randomFloatBetween(_KillAfterRandomNumberMin, _KillAfterRandomNumberMax), function(timeTask:TimedTask):Void
				{
					if((_DisappearEffectNumber == 0))
					{
						_customEvent_BlinkOut();
					}
				}, actor);
			}, actor);
		}
		else if(_GrowSelfDownAndKill)
		{
			actor.growTo(0/100, 0/100, _GrowTime, Linear.easeNone);
			runLater(1000 * (_GrowTime + 0.01), function(timeTask:TimedTask):Void
			{
				recycleActor(actor);
			}, actor);
		}
		
		/* ======================== When Updating ========================= */
		addWhenUpdatedListener(null, function(elapsedTime:Float, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled)
			{
				if(!(_GrowSelfDownAndKill))
				{
					if(!(actor.isAnimationPlaying()))
					{
						recycleActor(actor);
					}
					_RNGFrameTimeCheck = (_RNGFrameTimeCheck + 1);
					if((_RNGFrameTimeCheck <= randomInt(0, Std.int(_MaxStartAnimatingAfterRNG))))
					{
						actor.setCurrentFrame(0);
					}
				}
			}
		});
		
	}
	
	override public function forwardMessage(msg:String)
	{
		
	}
}