package scripts;

import com.stencyl.graphics.G;
import com.stencyl.graphics.BitmapWrapper;

import com.stencyl.behavior.Script;
import com.stencyl.behavior.Script.*;
import com.stencyl.behavior.ActorScript;
import com.stencyl.behavior.SceneScript;
import com.stencyl.behavior.TimedTask;

import com.stencyl.models.Actor;
import com.stencyl.models.GameModel;
import com.stencyl.models.actor.Animation;
import com.stencyl.models.actor.ActorType;
import com.stencyl.models.actor.Collision;
import com.stencyl.models.actor.Group;
import com.stencyl.models.Scene;
import com.stencyl.models.Sound;
import com.stencyl.models.Region;
import com.stencyl.models.Font;
import com.stencyl.models.Joystick;

import com.stencyl.Engine;
import com.stencyl.Input;
import com.stencyl.Key;
import com.stencyl.utils.Utils;

import openfl.ui.Mouse;
import openfl.display.Graphics;
import openfl.display.BlendMode;
import openfl.display.BitmapData;
import openfl.display.Bitmap;
import openfl.events.Event;
import openfl.events.KeyboardEvent;
import openfl.events.TouchEvent;
import openfl.net.URLLoader;

import box2D.common.math.B2Vec2;
import box2D.dynamics.B2Body;
import box2D.dynamics.B2Fixture;
import box2D.dynamics.joints.B2Joint;

import motion.Actuate;
import motion.easing.Back;
import motion.easing.Cubic;
import motion.easing.Elastic;
import motion.easing.Expo;
import motion.easing.Linear;
import motion.easing.Quad;
import motion.easing.Quart;
import motion.easing.Quint;
import motion.easing.Sine;

import com.stencyl.graphics.shaders.BasicShader;
import com.stencyl.graphics.shaders.GrayscaleShader;
import com.stencyl.graphics.shaders.SepiaShader;
import com.stencyl.graphics.shaders.InvertShader;
import com.stencyl.graphics.shaders.GrainShader;
import com.stencyl.graphics.shaders.ExternalShader;
import com.stencyl.graphics.shaders.InlineShader;
import com.stencyl.graphics.shaders.BlurShader;
import com.stencyl.graphics.shaders.SharpenShader;
import com.stencyl.graphics.shaders.ScanlineShader;
import com.stencyl.graphics.shaders.CSBShader;
import com.stencyl.graphics.shaders.HueShader;
import com.stencyl.graphics.shaders.TintShader;
import com.stencyl.graphics.shaders.BloomShader;



class Design_1_1_PlayerMovement extends ActorScript
{
	public var _Scarf:Actor;
	public var _Shadow:Actor;
	public var _Hit:Bool;
	public var _HitBuffer:Bool;
	public var _MaxSpeed:Float;
	public var _AlternatedStepSounds:Bool;
	public var _SoundDelay:Bool;
	public var _targetDirection:Float;
	public var decel:Float;
	public var _Acceleration:Float;
	
	/* ========================= Custom Event ========================= */
	public function _customEvent_EnterDungeon():Void
	{
		actor.setAnimation("Run");
		actor.fadeTo(0 / 100, 1, Linear.easeNone);
		for(actorOfType in getActorsOfType(getActorType(2)))
		{
			if(actorOfType != null && !actorOfType.dead && !actorOfType.recycled){
				actorOfType.fadeTo(0 / 100, 1, Linear.easeNone);
			}
		}
		for(actorOfType in getActorsOfType(getActorType(5)))
		{
			if(actorOfType != null && !actorOfType.dead && !actorOfType.recycled){
				actorOfType.fadeTo(0 / 100, 1, Linear.easeNone);
			}
		}
	}
	
	/* ========================= Custom Event ========================= */
	public function _customEvent_MoveRight():Void
	{
		actor.applyImpulse(1, 0, _Acceleration);
	}
	
	/* ========================= Custom Event ========================= */
	public function _customEvent_MoveLeft():Void
	{
		actor.applyImpulse(-1, 0, _Acceleration);
	}
	
	/* ========================= Custom Event ========================= */
	public function _customEvent_MoveDown():Void
	{
		actor.applyImpulse(0, 1, _Acceleration);
	}
	
	/* ========================= Custom Event ========================= */
	public function _customEvent_MoveUp():Void
	{
		actor.applyImpulse(0, -1, _Acceleration);
	}
	
	/* ========================= Custom Event ========================= */
	public function _customEvent_Damage():Void
	{
		if(!((actor.getActorValue("FirstSpawn?") : Bool)))
		{
			if(!(_HitBuffer))
			{
				if(!(_Hit))
				{
					_Hit = true;
					_HitBuffer = true;
					actor.setAnimation("Hit");
					actor.setXVelocity(0);
					actor.setYVelocity(0);
					/* "" */ playSound(getSound(135));
					if((actor.getActorValue("HitPushDir?") == "R"))
					{
						actor.setVelocity((0 + randomInt(-45, 45)), 25);
						actor.setActorValue("FacingRight?", false);
					}
					else if((actor.getActorValue("HitPushDir?") == "L"))
					{
						actor.setVelocity((180 + randomInt(-45, 45)), 25);
						actor.setActorValue("FacingRight?", true);
					}
					else if((actor.getActorValue("HitPushDir?") == "U"))
					{
						actor.setVelocity((-90 + randomInt(-45, 45)), 25);
					}
					else if((actor.getActorValue("HitPushDir?") == "D"))
					{
						actor.setVelocity((90 + randomInt(-45, 45)), 25);
					}
					startShakingScreen(0.5 / 100, 0.25);
					/* "" */ for(index0 in 0...2)
					{
						createRecycledActor(getActorType(21), (actor.getX() + randomInt(0, Std.int(((actor.getWidth()) - 5)))), (actor.getY() + randomInt(0, Std.int(((actor.getHeight()) - 5)))), Script.FRONT);
					}
					runLater(1000 * 0.05, function(timeTask:TimedTask):Void
					{
						createRecycledActor(getActorType(21), (actor.getX() + randomInt(0, Std.int(((actor.getWidth()) - 5)))), (actor.getY() + randomInt(0, Std.int(((actor.getHeight()) - 5)))), Script.FRONT);
						createRecycledActor(getActorType(11), ((actor.getXCenter() - 3) + randomInt(Std.int(-((actor.getWidth()))), Std.int((actor.getWidth())))), ((actor.getYCenter() - 3) + randomInt(Std.int(-((actor.getHeight()))), Std.int((actor.getHeight())))), Script.FRONT);
						runLater(1000 * 0.05, function(timeTask:TimedTask):Void
						{
							createRecycledActor(getActorType(21), (actor.getX() + randomInt(0, Std.int(((actor.getWidth()) - 5)))), (actor.getY() + randomInt(0, Std.int(((actor.getHeight()) - 5)))), Script.FRONT);
							createRecycledActor(getActorType(21), (actor.getX() + randomInt(0, Std.int(((actor.getWidth()) - 5)))), (actor.getY() + randomInt(0, Std.int(((actor.getHeight()) - 5)))), Script.FRONT);
							runLater(1000 * 0.05, function(timeTask:TimedTask):Void
							{
								createRecycledActor(getActorType(11), ((actor.getXCenter() - 3) + randomInt(Std.int(-((actor.getWidth()))), Std.int((actor.getWidth())))), ((actor.getYCenter() - 3) + randomInt(Std.int(-((actor.getHeight()))), Std.int((actor.getHeight())))), Script.FRONT);
								createRecycledActor(getActorType(21), (actor.getX() + randomInt(0, Std.int(((actor.getWidth()) - 5)))), (actor.getY() + randomInt(0, Std.int(((actor.getHeight()) - 5)))), Script.FRONT);
								runLater(1000 * 0.05, function(timeTask:TimedTask):Void
								{
									createRecycledActor(getActorType(21), (actor.getX() + randomInt(0, Std.int(((actor.getWidth()) - 5)))), (actor.getY() + randomInt(0, Std.int(((actor.getHeight()) - 5)))), Script.FRONT);
									runLater(1000 * 0.1, function(timeTask:TimedTask):Void
									{
										createRecycledActor(getActorType(21), (actor.getX() + randomInt(0, Std.int(((actor.getWidth()) - 5)))), (actor.getY() + randomInt(0, Std.int(((actor.getHeight()) - 5)))), Script.FRONT);
										runLater(1000 * 0.1, function(timeTask:TimedTask):Void
										{
											createRecycledActor(getActorType(21), (actor.getX() + randomInt(0, Std.int(((actor.getWidth()) - 5)))), (actor.getY() + randomInt(0, Std.int(((actor.getHeight()) - 5)))), Script.FRONT);
											runLater(1000 * 0.1, function(timeTask:TimedTask):Void
											{
												createRecycledActor(getActorType(21), (actor.getX() + randomInt(0, Std.int(((actor.getWidth()) - 5)))), (actor.getY() + randomInt(0, Std.int(((actor.getHeight()) - 5)))), Script.FRONT);
												runLater(1000 * 0.1, function(timeTask:TimedTask):Void
												{
													createRecycledActor(getActorType(21), (actor.getX() + randomInt(0, Std.int(((actor.getWidth()) - 5)))), (actor.getY() + randomInt(0, Std.int(((actor.getHeight()) - 5)))), Script.FRONT);
													runLater(1000 * 0.1, function(timeTask:TimedTask):Void
													{
														createRecycledActor(getActorType(21), (actor.getX() + randomInt(0, Std.int(((actor.getWidth()) - 5)))), (actor.getY() + randomInt(0, Std.int(((actor.getHeight()) - 5)))), Script.FRONT);
														runLater(1000 * 0.1, function(timeTask:TimedTask):Void
														{
															createRecycledActor(getActorType(21), (actor.getX() + randomInt(0, Std.int(((actor.getWidth()) - 5)))), (actor.getY() + randomInt(0, Std.int(((actor.getHeight()) - 5)))), Script.FRONT);
															runLater(1000 * 0.1, function(timeTask:TimedTask):Void
															{
																createRecycledActor(getActorType(21), (actor.getX() + randomInt(0, Std.int(((actor.getWidth()) - 5)))), (actor.getY() + randomInt(0, Std.int(((actor.getHeight()) - 5)))), Script.FRONT);
															}, actor);
														}, actor);
													}, actor);
												}, actor);
											}, actor);
										}, actor);
									}, actor);
								}, actor);
							}, actor);
						}, actor);
					}, actor);
					/* "" */ Engine.engine.setGameAttribute("Hearts", ((Engine.engine.getGameAttribute("Hearts") : Float) - 1));
					if(((Engine.engine.getGameAttribute("Hearts") : Float) <= 0))
					{
						actor.setActorValue("Die?", true);
						Engine.engine.setGameAttribute("FirstSpawn", true);
						createRecycledActor(getActorType(62), 0, 0, Script.FRONT);
						getLastCreatedActor().shout("_customEvent_" + "Flash1");
						playSound(getSound(157));
						for(actorOfType in getActorsOfType(getActorType(5)))
						{
							if(actorOfType != null && !actorOfType.dead && !actorOfType.recycled){
								actorOfType.disableActorDrawing();
							}
						}
						runLater(1000 * 0.3, function(timeTask:TimedTask):Void
						{
							createRecycledActor(getActorType(60), 0, 0, Script.FRONT);
							getLastCreatedActor().shout("_customEvent_" + "PlayerDeath");
							createRecycledActor(getActorType(62), 0, 0, Script.FRONT);
							getLastCreatedActor().shout("_customEvent_" + "Flash2");
							/* "" */ createRecycledActor(getActorType(64), actor.getScreenX(), actor.getScreenY(), Script.FRONT);
							if((actor.getActorValue("FacingRight?") : Bool))
							{
								getLastCreatedActor().growTo(100/100, 100/100, 0, Linear.easeNone);
							}
							else
							{
								getLastCreatedActor().growTo(-100/100, 100/100, 0, Linear.easeNone);
							}
							for(actorOfType in getActorsOfType(getActorType(58)))
							{
								if(actorOfType != null && !actorOfType.dead && !actorOfType.recycled){
									actorOfType.shout("_customEvent_" + "FadeOut");
								}
							}
							shoutToScene("_customEvent_" + "DeathReset");
							actor.disableActorDrawing();
						}, actor);
					}
					else
					{
						runLater(1000 * 0.35, function(timeTask:TimedTask):Void
						{
							_Hit = false;
						}, actor);
						runLater(1000 * 0.8, function(timeTask:TimedTask):Void
						{
							_HitBuffer = false;
						}, actor);
					}
					/* "" */ if(((Engine.engine.getGameAttribute("Hearts") : Float) >= 1))
					{
						actor.disableActorDrawing();
						runLater(1000 * 0.05, function(timeTask:TimedTask):Void
						{
							actor.enableActorDrawing();
							runLater(1000 * 0.05, function(timeTask:TimedTask):Void
							{
								actor.disableActorDrawing();
								runLater(1000 * 0.05, function(timeTask:TimedTask):Void
								{
									actor.enableActorDrawing();
									runLater(1000 * 0.05, function(timeTask:TimedTask):Void
									{
										actor.disableActorDrawing();
										runLater(1000 * 0.05, function(timeTask:TimedTask):Void
										{
											actor.enableActorDrawing();
											runLater(1000 * 0.05, function(timeTask:TimedTask):Void
											{
												actor.fadeTo(30 / 100, 0, Linear.easeNone);
												runLater(1000 * 0.05, function(timeTask:TimedTask):Void
												{
													actor.fadeTo(100 / 100, 0, Linear.easeNone);
													runLater(1000 * 0.05, function(timeTask:TimedTask):Void
													{
														actor.fadeTo(50 / 100, 0, Linear.easeNone);
														runLater(1000 * 0.05, function(timeTask:TimedTask):Void
														{
															actor.fadeTo(100 / 100, 0, Linear.easeNone);
															runLater(1000 * 0.05, function(timeTask:TimedTask):Void
															{
																actor.fadeTo(60 / 100, 0, Linear.easeNone);
																runLater(1000 * 0.05, function(timeTask:TimedTask):Void
																{
																	actor.fadeTo(100 / 100, 0, Linear.easeNone);
																	runLater(1000 * 0.05, function(timeTask:TimedTask):Void
																	{
																		actor.fadeTo(70 / 100, 0, Linear.easeNone);
																		runLater(1000 * 0.05, function(timeTask:TimedTask):Void
																		{
																			actor.fadeTo(100 / 100, 0, Linear.easeNone);
																		}, actor);
																	}, actor);
																}, actor);
															}, actor);
														}, actor);
													}, actor);
												}, actor);
											}, actor);
										}, actor);
									}, actor);
								}, actor);
							}, actor);
						}, actor);
					}
				}
			}
		}
	}
	
	
	public function new(dummy:Int, actor:Actor, dummy2:Engine)
	{
		super(actor);
		nameMap.set("Actor", "actor");
		nameMap.set("Scarf", "_Scarf");
		nameMap.set("Shadow", "_Shadow");
		nameMap.set("Hit?", "_Hit");
		_Hit = false;
		nameMap.set("HitBuffer?", "_HitBuffer");
		_HitBuffer = false;
		nameMap.set("MaxSpeed", "_MaxSpeed");
		_MaxSpeed = 12.0;
		nameMap.set("AlternatedStepSounds", "_AlternatedStepSounds");
		_AlternatedStepSounds = false;
		nameMap.set("SoundDelay", "_SoundDelay");
		_SoundDelay = false;
		nameMap.set("targetDirection", "_targetDirection");
		_targetDirection = 0.0;
		nameMap.set("Slowdown Rate", "decel");
		decel = 0.0;
		nameMap.set("Acceleration", "_Acceleration");
		_Acceleration = 10.0;
		
	}
	
	override public function init()
	{
		
		/* ======================== When Creating ========================= */
		createRecycledActor(getActorType(2), -500, -500, Script.BACK);
		getLastCreatedActor().moveToLayer(engine.getLayerById(actor.getLayerID()));
		getLastCreatedActor().setZIndex(0);
		_Scarf = getLastCreatedActor();
		createRecycledActor(getActorType(7), -500, -500, Script.BACK);
		getLastCreatedActor().moveToLayer(engine.getLayerByName("Below2"));
		getLastCreatedActor().setZIndex(0);
		_Shadow = getLastCreatedActor();
		/* "" */ runPeriodically(1000 * 0.05, function(timeTask:TimedTask):Void
		{
			if((actor.getAnimation() == "Run"))
			{
				if((actor.getCurrentFrame() == 3))
				{
					if(_AlternatedStepSounds)
					{
						_AlternatedStepSounds = false;
						if(!(_SoundDelay))
						{
							_SoundDelay = true;
							playSound(getSound(131));
							runLater(1000 * 0.05, function(timeTask:TimedTask):Void
							{
								_SoundDelay = false;
							}, actor);
						}
					}
					else
					{
						_AlternatedStepSounds = true;
						if(!(_SoundDelay))
						{
							_SoundDelay = true;
							playSound(getSound(132));
							runLater(1000 * 0.05, function(timeTask:TimedTask):Void
							{
								_SoundDelay = false;
							}, actor);
						}
					}
				}
			}
		}, actor);
		/* "" */ if((Engine.engine.getGameAttribute("FirstSpawn") : Bool))
		{
			actor.setActorValue("FirstSpawn?", true);
			actor.fadeTo(0 / 100, 0, Linear.easeNone);
			for(actorOfType in getActorsOfType(getActorType(2)))
			{
				if(actorOfType != null && !actorOfType.dead && !actorOfType.recycled){
					actorOfType.disableActorDrawing();
				}
			}
			for(actorOfType in getActorsOfType(getActorType(7)))
			{
				if(actorOfType != null && !actorOfType.dead && !actorOfType.recycled){
					actorOfType.disableActorDrawing();
				}
			}
			runLater(1000 * 0.75, function(timeTask:TimedTask):Void
			{
				actor.setActorValue("FirstSpawn?", false);
				actor.fadeTo(100 / 100, 0, Linear.easeNone);
				for(actorOfType in getActorsOfType(getActorType(5)))
				{
					if(actorOfType != null && !actorOfType.dead && !actorOfType.recycled){
						actorOfType.enableActorDrawing();
					}
				}
				for(actorOfType in getActorsOfType(getActorType(2)))
				{
					if(actorOfType != null && !actorOfType.dead && !actorOfType.recycled){
						actorOfType.enableActorDrawing();
					}
				}
				for(actorOfType in getActorsOfType(getActorType(7)))
				{
					if(actorOfType != null && !actorOfType.dead && !actorOfType.recycled){
						actorOfType.enableActorDrawing();
					}
				}
				createRecycledActor(getActorType(70), (actor.getXCenter() - 8), (actor.getY() - 40), Script.FRONT);
				Engine.engine.setGameAttribute("FirstSpawn", false);
			}, actor);
		}
		else
		{
			actor.setActorValue("FirstSpawn?", false);
		}
		
		/* ======================== When Updating ========================= */
		addWhenUpdatedListener(null, function(elapsedTime:Float, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled)
			{
				if((hasValue(_Scarf)))
				{
					_Scarf.setX((actor.getX() + -8));
					_Scarf.setY((actor.getY() + 9));
				}
				if((hasValue(_Shadow)))
				{
					_Shadow.setX((actor.getX() + 4));
					_Shadow.setY((actor.getY() + 22));
				}
			}
		});
		
		/* ======================== When Updating ========================= */
		addWhenUpdatedListener(null, function(elapsedTime:Float, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled)
			{
				if((!((actor.getActorValue("UsingStore?") : Bool)) && !((actor.getActorValue("Entering Dungeon?") : Bool))))
				{
					if(!((actor.getActorValue("FirstSpawn?") : Bool)))
					{
						if(!(_Hit))
						{
							if(!((actor.getActorValue("Die?") : Bool)))
							{
								/* When Reach Max Speed */
								if((actor.getXVelocity() >= _MaxSpeed))
								{
									actor.setXVelocity(_MaxSpeed);
								}
								else if((actor.getXVelocity() <= -(_MaxSpeed)))
								{
									actor.setXVelocity(-(_MaxSpeed));
								}
								if((actor.getYVelocity() >= _MaxSpeed))
								{
									actor.setYVelocity(_MaxSpeed);
								}
								else if((actor.getYVelocity() <= -(_MaxSpeed)))
								{
									actor.setYVelocity(-(_MaxSpeed));
								}
								/* SlowDown if not press */
								if((!((actor.getActorValue("AnalogStickMove?") : Bool)) || (actor.getActorValue("Attacking?") : Bool)))
								{
									if(((!(isKeyPressed("left")) && !(isKeyPressed("right"))) || (actor.getActorValue("Attacking?") : Bool)))
									{
										actor.setXVelocity((actor.getXVelocity() * decel));
									}
									if(((!(isKeyPressed("up")) && !(isKeyPressed("down"))) || (actor.getActorValue("Attacking?") : Bool)))
									{
										actor.setYVelocity((actor.getYVelocity() * decel));
									}
								}
								else
								{
									actor.setXVelocity((actor.getXVelocity() * decel));
									actor.setYVelocity((actor.getYVelocity() * decel));
								}
								/* Keys */
								if((!((actor.getActorValue("Attacking?") : Bool)) && !((actor.getActorValue("AnalogStickMove?") : Bool))))
								{
									if(isKeyDown("right"))
									{
										actor.setActorValue("Walk", true);
										_customEvent_MoveRight();
									}
									else if(isKeyDown("left"))
									{
										actor.setActorValue("Walk", true);
										_customEvent_MoveLeft();
									}
									if(isKeyDown("up"))
									{
										actor.setActorValue("Walk", true);
										_customEvent_MoveUp();
									}
									else if(isKeyDown("down"))
									{
										actor.setActorValue("Walk", true);
										_customEvent_MoveDown();
									}
								}
								else if((!((actor.getActorValue("Attacking?") : Bool)) && (actor.getActorValue("AnalogStickMove?") : Bool)))
								{
									actor.setActorValue("Walk", true);
									actor.setVelocity(asNumber(getValueForScene("Scene_Setter_", "_AnalogDegree")), 9);
								}
								if(((!(isKeyDown("left")) && (!(isKeyDown("right")) && (!(isKeyDown("down")) && !(isKeyDown("up"))))) && !((actor.getActorValue("AnalogStickMove?") : Bool))))
								{
									actor.setActorValue("Walk", false);
								}
								/* Animation */
								if((((actor.getXVelocity() < 1) && (actor.getXVelocity() > -1)) && ((actor.getYVelocity() < 1) && (actor.getYVelocity() > -1))))
								{
									actor.setAnimation("Idle");
								}
								else
								{
									actor.setAnimation("Run");
								}
								/* "" */ if((actor.getXVelocity() >= 1))
								{
									actor.setActorValue("FacingRight?", true);
								}
								else if((actor.getXVelocity() <= -1))
								{
									actor.setActorValue("FacingRight?", false);
								}
							}
						}
						else
						{
							actor.setXVelocity((actor.getXVelocity() * decel));
							actor.setYVelocity((actor.getYVelocity() * decel));
							if((actor.getXVelocity() >= 0.5))
							{
								actor.setActorValue("FacingRight?", false);
							}
							else if((actor.getXVelocity() <= -0.5))
							{
								actor.setActorValue("FacingRight?", true);
							}
						}
						/* "" */ if((actor.getActorValue("FacingRight?") : Bool))
						{
							actor.growTo(100/100, 100/100, 0, Linear.easeNone);
						}
						else
						{
							actor.growTo(-100/100, 100/100, 0, Linear.easeNone);
						}
					}
				}
				else
				{
					actor.setXVelocity((actor.getXVelocity() * decel));
					actor.setYVelocity((actor.getYVelocity() * decel));
				}
			}
		});
		
	}
	
	override public function forwardMessage(msg:String)
	{
		
	}
}