package scripts;

import com.stencyl.graphics.G;
import com.stencyl.graphics.BitmapWrapper;

import com.stencyl.behavior.Script;
import com.stencyl.behavior.Script.*;
import com.stencyl.behavior.ActorScript;
import com.stencyl.behavior.SceneScript;
import com.stencyl.behavior.TimedTask;

import com.stencyl.models.Actor;
import com.stencyl.models.GameModel;
import com.stencyl.models.actor.Animation;
import com.stencyl.models.actor.ActorType;
import com.stencyl.models.actor.Collision;
import com.stencyl.models.actor.Group;
import com.stencyl.models.Scene;
import com.stencyl.models.Sound;
import com.stencyl.models.Region;
import com.stencyl.models.Font;
import com.stencyl.models.Joystick;

import com.stencyl.Engine;
import com.stencyl.Input;
import com.stencyl.Key;
import com.stencyl.utils.Utils;

import openfl.ui.Mouse;
import openfl.display.Graphics;
import openfl.display.BlendMode;
import openfl.display.BitmapData;
import openfl.display.Bitmap;
import openfl.events.Event;
import openfl.events.KeyboardEvent;
import openfl.events.TouchEvent;
import openfl.net.URLLoader;

import box2D.common.math.B2Vec2;
import box2D.dynamics.B2Body;
import box2D.dynamics.B2Fixture;
import box2D.dynamics.joints.B2Joint;

import motion.Actuate;
import motion.easing.Back;
import motion.easing.Cubic;
import motion.easing.Elastic;
import motion.easing.Expo;
import motion.easing.Linear;
import motion.easing.Quad;
import motion.easing.Quart;
import motion.easing.Quint;
import motion.easing.Sine;

import com.stencyl.graphics.shaders.BasicShader;
import com.stencyl.graphics.shaders.GrayscaleShader;
import com.stencyl.graphics.shaders.SepiaShader;
import com.stencyl.graphics.shaders.InvertShader;
import com.stencyl.graphics.shaders.GrainShader;
import com.stencyl.graphics.shaders.ExternalShader;
import com.stencyl.graphics.shaders.InlineShader;
import com.stencyl.graphics.shaders.BlurShader;
import com.stencyl.graphics.shaders.SharpenShader;
import com.stencyl.graphics.shaders.ScanlineShader;
import com.stencyl.graphics.shaders.CSBShader;
import com.stencyl.graphics.shaders.HueShader;
import com.stencyl.graphics.shaders.TintShader;
import com.stencyl.graphics.shaders.BloomShader;



class Design_23_23_CameraOrigin extends ActorScript
{
	public var _CameraRelative:Actor;
	public var _PlayerGroup:Group;
	public var _CameraPanPlayerX:Float;
	
	
	public function new(dummy:Int, actor:Actor, dummy2:Engine)
	{
		super(actor);
		nameMap.set("Actor", "actor");
		nameMap.set("CameraRelative", "_CameraRelative");
		nameMap.set("PlayerGroup", "_PlayerGroup");
		nameMap.set("CameraPanPlayerX", "_CameraPanPlayerX");
		_CameraPanPlayerX = 0.0;
		
	}
	
	override public function init()
	{
		
		/* ======================== When Creating ========================= */
		createRecycledActor(getActorType(28), actor.getX(), actor.getY(), Script.FRONT);
		_CameraRelative = getLastCreatedActor();
		actor.setActorValue("Moving?", false);
		actor.setActorValue("PlayerFollow?", false);
		_PlayerGroup = getActorGroup(0);
		runLater(1000 * 0.01, function(timeTask:TimedTask):Void
		{
			actor.setActorValue("OriginalX", actor.getX());
			actor.setActorValue("OriginalY", actor.getY());
		}, actor);
		
		/* ======================== When Updating ========================= */
		addWhenUpdatedListener(null, function(elapsedTime:Float, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled)
			{
				/* "" */ for(actorInGroup in cast(getActorGroup(0), Group).list)
				{
					if(actorInGroup != null && !actorInGroup.dead && !actorInGroup.recycled){
						if(!((actor.getActorValue("ModifiedCam?") : Bool)))
						{
							actor.setX((actorInGroup.getXCenter() - 1));
							actor.setY((actorInGroup.getYCenter() - 1));
						}
					}
				}
				/* "Boundary for scene" */ if((actor.getXCenter() >= (getSceneWidth() - (getScreenWidth() / 2))))
				{
					actor.setX((getSceneWidth() - (getScreenWidth() / 2)));
				}
				else if((actor.getXCenter() <= (getScreenWidth() / 2)))
				{
					actor.setX((getScreenWidth() / 2));
				}
				if((actor.getYCenter() >= (getSceneHeight() - (getScreenHeight() / 2))))
				{
					actor.setY((getSceneHeight() - (getScreenHeight() / 2)));
				}
				else if((actor.getYCenter() <= (getScreenHeight() / 2)))
				{
					actor.setY((getScreenHeight() / 2));
				}
			}
		});
		
	}
	
	override public function forwardMessage(msg:String)
	{
		
	}
}