package scripts;

import com.stencyl.graphics.G;
import com.stencyl.graphics.BitmapWrapper;

import com.stencyl.behavior.Script;
import com.stencyl.behavior.Script.*;
import com.stencyl.behavior.ActorScript;
import com.stencyl.behavior.SceneScript;
import com.stencyl.behavior.TimedTask;

import com.stencyl.models.Actor;
import com.stencyl.models.GameModel;
import com.stencyl.models.actor.Animation;
import com.stencyl.models.actor.ActorType;
import com.stencyl.models.actor.Collision;
import com.stencyl.models.actor.Group;
import com.stencyl.models.Scene;
import com.stencyl.models.Sound;
import com.stencyl.models.Region;
import com.stencyl.models.Font;
import com.stencyl.models.Joystick;

import com.stencyl.Engine;
import com.stencyl.Input;
import com.stencyl.Key;
import com.stencyl.utils.Utils;

import openfl.ui.Mouse;
import openfl.display.Graphics;
import openfl.display.BlendMode;
import openfl.display.BitmapData;
import openfl.display.Bitmap;
import openfl.events.Event;
import openfl.events.KeyboardEvent;
import openfl.events.TouchEvent;
import openfl.net.URLLoader;

import box2D.common.math.B2Vec2;
import box2D.dynamics.B2Body;
import box2D.dynamics.B2Fixture;
import box2D.dynamics.joints.B2Joint;
import box2D.collision.shapes.B2Shape;

import motion.Actuate;
import motion.easing.Back;
import motion.easing.Cubic;
import motion.easing.Elastic;
import motion.easing.Expo;
import motion.easing.Linear;
import motion.easing.Quad;
import motion.easing.Quart;
import motion.easing.Quint;
import motion.easing.Sine;

import com.stencyl.graphics.shaders.BasicShader;
import com.stencyl.graphics.shaders.GrayscaleShader;
import com.stencyl.graphics.shaders.SepiaShader;
import com.stencyl.graphics.shaders.InvertShader;
import com.stencyl.graphics.shaders.GrainShader;
import com.stencyl.graphics.shaders.ExternalShader;
import com.stencyl.graphics.shaders.InlineShader;
import com.stencyl.graphics.shaders.BlurShader;
import com.stencyl.graphics.shaders.SharpenShader;
import com.stencyl.graphics.shaders.ScanlineShader;
import com.stencyl.graphics.shaders.CSBShader;
import com.stencyl.graphics.shaders.HueShader;
import com.stencyl.graphics.shaders.TintShader;
import com.stencyl.graphics.shaders.BloomShader;



class Design_25_25_SceneSetter extends SceneScript
{
	public var _SoundNumb:Float;
	public var _WhichMapItemNumb:Float;
	public var _AudioMap:Map<String,Dynamic>;
	public var _SoundName:String;
	public var _AnalogDegree:Float;
	public var _AnalogPressureH:Float;
	public var _AnalogPressureV:Float;
	public var _AnalogDistanceX:Float;
	public var _AnalogDistanceY:Float;
	public var _AnalogDistance:Float;
	
	/* ========================= Custom Event ========================= */
	public function _customEvent_DeathReset():Void
	{
		createRecycledActor(getActorType(66), ((getScreenWidth() / 2) - 25), 50, Script.FRONT);
		createRecycledActor(getActorType(68), ((getScreenWidth() / 2) - 36), 30, Script.FRONT);
		runLater(1000 * 2, function(timeTask:TimedTask):Void
		{
			for(actorOfType in getActorsOfType(getActorType(66)))
			{
				if(actorOfType != null && !actorOfType.dead && !actorOfType.recycled){
					actorOfType.shout("_customEvent_" + "ReduceSouls");
				}
			}
		}, null);
		runLater(1000 * 3.5, function(timeTask:TimedTask):Void
		{
			Engine.engine.setGameAttribute("Hearts", 3);
			saveGame("mySave", function(success:Bool):Void
			{
				
			});
			switchScene(GameModel.get().scenes.get(1).getID(), createFadeOut(1, Utils.getColorRGB(0,0,0)), createFadeIn(1, Utils.getColorRGB(0,0,0)));
		}, null);
	}
	
	/* ========================= Custom Event ========================= */
	public function _customEvent_PlaySoundLimit():Void
	{
		if(!(Utils.mapContainsValue(_AudioMap, _SoundName)))
		{
			playSound(getSoundByName(_SoundName));
			_AudioMap.set(("" + _WhichMapItemNumb), _SoundName);
			_WhichMapItemNumb = (_WhichMapItemNumb + 1);
		}
	}
	
	
	public function new(dummy:Int, dummy2:Engine)
	{
		super();
		nameMap.set("SoundNumb", "_SoundNumb");
		_SoundNumb = 0.0;
		nameMap.set("WhichMapItemNumb?", "_WhichMapItemNumb");
		_WhichMapItemNumb = 1.0;
		nameMap.set("AudioMap", "_AudioMap");
		nameMap.set("SoundName?", "_SoundName");
		_SoundName = "";
		nameMap.set("AnalogDegree", "_AnalogDegree");
		_AnalogDegree = 0.0;
		nameMap.set("AnalogPressureH", "_AnalogPressureH");
		_AnalogPressureH = 0.0;
		nameMap.set("AnalogPressureV", "_AnalogPressureV");
		_AnalogPressureV = 0.0;
		nameMap.set("AnalogDistanceX", "_AnalogDistanceX");
		_AnalogDistanceX = 0.0;
		nameMap.set("AnalogDistanceY", "_AnalogDistanceY");
		_AnalogDistanceY = 0.0;
		nameMap.set("AnalogDistance", "_AnalogDistance");
		_AnalogDistance = 0.0;
		
	}
	
	override public function init()
	{
		
		/* ======================== When Creating ========================= */
		_AudioMap = new Map<String, Dynamic>();
		setOffscreenTolerance(25, 25, 25, 25);
		engine.unpause();
		createRecycledActor(getActorType(26), (getSceneWidth() / 2), (getSceneHeight() / 2), Script.FRONT);
		createRecycledActor(getActorType(41), -500, -500, Script.FRONT);
		/* "UI" */ createRecycledActor(getActorType(56), 8, 8, Script.FRONT);
		createRecycledActor(getActorType(58), 8, 23, Script.FRONT);
		/* "" */ Input.enableJoystick();
		Input.setJoySensitivity(0 / 100);
		/* "D-PAD" */ Input.mapJoystickButton("0, left hat", "left");
		Input.mapJoystickButton("0, right hat", "right");
		Input.mapJoystickButton("0, up hat", "up");
		Input.mapJoystickButton("0, down hat", "down");
		/* "Analog Stick1" */ Input.mapJoystickButton("0, -axis 0", "Left_Analog");
		Input.mapJoystickButton("0, +axis 0", "Right_Analog");
		Input.mapJoystickButton("0, -axis 1", "Up_Analog");
		Input.mapJoystickButton("0, +axis 1", "Down_Analog");
		Input.mapJoystickButton("0, 0", "Attack");
		
		/* ======================== When Updating ========================= */
		addWhenUpdatedListener(null, function(elapsedTime:Float, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled)
			{
				/* Analog stick control direction/ sensitvity detection in here. */
				if(isKeyDown("Right_Analog"))
				{
					_AnalogPressureH = Input.getButtonPressure("Right_Analog");
				}
				else if(isKeyDown("Left_Analog"))
				{
					_AnalogPressureH = -(Input.getButtonPressure("Left_Analog"));
				}
				else
				{
					_AnalogPressureH = 0;
				}
				if(isKeyDown("Up_Analog"))
				{
					_AnalogPressureV = -(Input.getButtonPressure("Up_Analog"));
				}
				else if(isKeyDown("Down_Analog"))
				{
					_AnalogPressureV = Input.getButtonPressure("Down_Analog");
				}
				else
				{
					_AnalogPressureV = 0;
				}
				/* "Sets direction degree." */ _AnalogDegree = Utils.DEG * (Math.atan2(_AnalogPressureV, _AnalogPressureH));
				/* Distance from center analog range: 0 -> 1 */
				_AnalogDistance = asNumber(Math.sqrt((Math.pow(_AnalogPressureH, 2) + Math.pow(_AnalogPressureV, 2))));
				/* "Transforms the top-negative degrees into positive, so it's a 'full' 360 degrees." */ if((_AnalogDegree < 0))
				{
					_AnalogDegree = (360 - Math.abs(_AnalogDegree));
				}
				/* "" */ for(actorInGroup in cast(getActorGroup(0), Group).list)
				{
					if(actorInGroup != null && !actorInGroup.dead && !actorInGroup.recycled){
						if((_AnalogDistance >= 0.05))
						{
							actorInGroup.setActorValue("AnalogStickMove?", true);
						}
						else
						{
							actorInGroup.setActorValue("AnalogStickMove?", false);
						}
					}
				}
				trace(_AnalogDegree);
			}
		});
		
		/* ======================== When Updating ========================= */
		addWhenUpdatedListener(null, function(elapsedTime:Float, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled)
			{
				/* "" */ _SoundNumb = (_SoundNumb + 1);
				/* "" */ if(Utils.mapCount(_AudioMap) == 0)
				{
					_SoundNumb = 0;
					_WhichMapItemNumb = 1;
				}
				else
				{
					for(item in (_AudioMap : Map<String,Dynamic>).keys())
					{
						if((_SoundNumb >= (asNumber(item) * 10)))
						{
							_AudioMap.remove("" + item);
						}
					}
				}
			}
		});
		
	}
	
	override public function forwardMessage(msg:String)
	{
		
	}
}