package scripts;

import com.stencyl.graphics.G;
import com.stencyl.graphics.BitmapWrapper;

import com.stencyl.behavior.Script;
import com.stencyl.behavior.Script.*;
import com.stencyl.behavior.ActorScript;
import com.stencyl.behavior.SceneScript;
import com.stencyl.behavior.TimedTask;

import com.stencyl.models.Actor;
import com.stencyl.models.GameModel;
import com.stencyl.models.actor.Animation;
import com.stencyl.models.actor.ActorType;
import com.stencyl.models.actor.Collision;
import com.stencyl.models.actor.Group;
import com.stencyl.models.Scene;
import com.stencyl.models.Sound;
import com.stencyl.models.Region;
import com.stencyl.models.Font;
import com.stencyl.models.Joystick;

import com.stencyl.Engine;
import com.stencyl.Input;
import com.stencyl.Key;
import com.stencyl.utils.Utils;

import openfl.ui.Mouse;
import openfl.display.Graphics;
import openfl.display.BlendMode;
import openfl.display.BitmapData;
import openfl.display.Bitmap;
import openfl.events.Event;
import openfl.events.KeyboardEvent;
import openfl.events.TouchEvent;
import openfl.net.URLLoader;

import box2D.common.math.B2Vec2;
import box2D.dynamics.B2Body;
import box2D.dynamics.B2Fixture;
import box2D.dynamics.joints.B2Joint;

import motion.Actuate;
import motion.easing.Back;
import motion.easing.Cubic;
import motion.easing.Elastic;
import motion.easing.Expo;
import motion.easing.Linear;
import motion.easing.Quad;
import motion.easing.Quart;
import motion.easing.Quint;
import motion.easing.Sine;

import com.stencyl.graphics.shaders.BasicShader;
import com.stencyl.graphics.shaders.GrayscaleShader;
import com.stencyl.graphics.shaders.SepiaShader;
import com.stencyl.graphics.shaders.InvertShader;
import com.stencyl.graphics.shaders.GrainShader;
import com.stencyl.graphics.shaders.ExternalShader;
import com.stencyl.graphics.shaders.InlineShader;
import com.stencyl.graphics.shaders.BlurShader;
import com.stencyl.graphics.shaders.SharpenShader;
import com.stencyl.graphics.shaders.ScanlineShader;
import com.stencyl.graphics.shaders.CSBShader;
import com.stencyl.graphics.shaders.HueShader;
import com.stencyl.graphics.shaders.TintShader;
import com.stencyl.graphics.shaders.BloomShader;



class Design_31_31_ERunner extends ActorScript
{
	public var _Hit:Bool;
	public var _DistanceX:Float;
	public var _DistanceY:Float;
	public var _Direction:Float;
	public var _HP:Float;
	public var decel:Float;
	public var _DisableDamagePlayer:Bool;
	public var _DisableDamagePlayerNumber:Float;
	public var _Wandering:Bool;
	public var _MaxSpeed:Float;
	public var _RNG:Float;
	public var _WanderPixelLimits:Float;
	public var _Moving:Bool;
	public var _Shadow:Actor;
	public var _Die:Bool;
	public var _TurningSpeed:Float;
	public var _OriginalX:Float;
	public var _OriginalY:Float;
	public var _FirstAlert:Bool;
	public var _FollowPlayer:Bool;
	public var _EnemyAlertThing:Actor;
	public var _StopPlayerFollow:Bool;
	public var _StopFollowPlayerNumb:Float;
	
	/* ========================= Custom Event ========================= */
	public function _customEvent_Death():Void
	{
		if(!(_Die))
		{
			_Die = true;
			recycleActor(_Shadow);
			actor.setAnimation("Dead");
			playSound(getSound(137));
			for(actorOfType in getActorsOfType(getActorType(41)))
			{
				if(actorOfType != null && !actorOfType.dead && !actorOfType.recycled){
					actorOfType.shout("_customEvent_" + "TimeEffect1");
				}
			}
			actor.spinBy(randomInt(-900, 900), 0.75, Quad.easeOut);
			startShakingScreen(0.5 / 100, 0.2);
			runLater(1000 * 0.2, function(timeTask:TimedTask):Void
			{
				startShakingScreen(0.3 / 100, 0.1);
			}, actor);
			createRecycledActor(getActorType(43), (actor.getXCenter() - 32), (actor.getYCenter() - 32), Script.FRONT);
			/* "" */ runPeriodically(1000 * 0.1, function(timeTask:TimedTask):Void
			{
				createRecycledActor(getActorType(21), (actor.getX() + randomInt(0, Std.int(((actor.getWidth()) - 5)))), (actor.getY() + randomInt(0, Std.int(((actor.getHeight()) - 5)))), Script.FRONT);
				createRecycledActor(getActorType(11), ((actor.getXCenter() - 3) + randomInt(Std.int(-((actor.getWidth()))), Std.int((actor.getWidth())))), ((actor.getYCenter() - 3) + randomInt(Std.int(-((actor.getHeight()))), Std.int((actor.getHeight())))), Script.FRONT);
			}, actor);
			for(actorInGroup in cast(getActorGroup(0), Group).list)
			{
				if(actorInGroup != null && !actorInGroup.dead && !actorInGroup.recycled){
					_DistanceX = (actorInGroup.getXCenter() - actor.getXCenter());
					_DistanceY = (actorInGroup.getYCenter() - actor.getYCenter());
					_Direction = Utils.DEG * (Math.atan2(_DistanceY, _DistanceX));
					actor.applyImpulseInDirection((_Direction + 180), 75);
				}
			}
			runLater(1000 * 0.75, function(timeTask:TimedTask):Void
			{
				actor.disableActorDrawing();
				startShakingScreen(0.5 / 100, 0.3);
				playSound(getSound(136));
				/* "Loot" */ _RNG = randomInt(1, 2);
				if((_RNG == 1))
				{
					for(index0 in 0...2)
					{
						createRecycledActor(getActorType(52), ((actor.getXCenter() - 5) + randomInt(-16, 16)), ((actor.getYCenter() - 5) + randomInt(-16, 16)), Script.FRONT);
						getLastCreatedActor().shout("_customEvent_" + "Enemy_Runner");
					}
				}
				else if((_RNG == 2))
				{
					createRecycledActor(getActorType(52), ((actor.getXCenter() - 5) + randomInt(-16, 16)), ((actor.getYCenter() - 5) + randomInt(-16, 16)), Script.FRONT);
					getLastCreatedActor().shout("_customEvent_" + "Enemy_Runner");
				}
				createRecycledActor(getActorType(43), (actor.getXCenter() - 32), (actor.getYCenter() - 32), Script.FRONT);
				for(index0 in 0...2)
				{
					createRecycledActor(getActorType(23), (actor.getXCenter() - 29), (actor.getYCenter() - 2), Script.FRONT);
					getLastCreatedActor().shout("_customEvent_" + "Death1");
				}
				for(index0 in 0...3)
				{
					createRecycledActor(getActorType(39), ((actor.getXCenter() - 6) + randomInt(-(20), 20)), ((actor.getYCenter() - 6) + randomInt(-(20), 20)), Script.FRONT);
				}
				runLater(1000 * 0.05, function(timeTask:TimedTask):Void
				{
					for(index0 in 0...3)
					{
						createRecycledActor(getActorType(39), ((actor.getXCenter() - 6) + randomInt(-(20), 20)), ((actor.getYCenter() - 6) + randomInt(-(20), 20)), Script.FRONT);
					}
					if((hasValue(_EnemyAlertThing)))
					{
						if(_EnemyAlertThing.isAlive())
						{
							recycleActor(_EnemyAlertThing);
						}
					}
					recycleActor(actor);
				}, actor);
			}, actor);
		}
	}
	
	
	public function new(dummy:Int, actor:Actor, dummy2:Engine)
	{
		super(actor);
		nameMap.set("Actor", "actor");
		nameMap.set("Hit?", "_Hit");
		_Hit = false;
		nameMap.set("Distance X", "_DistanceX");
		_DistanceX = 0.0;
		nameMap.set("Distance Y", "_DistanceY");
		_DistanceY = 0.0;
		nameMap.set("Direction", "_Direction");
		_Direction = 0.0;
		nameMap.set("HP", "_HP");
		_HP = 7.0;
		nameMap.set("Slowdown Rate", "decel");
		decel = 0.91;
		nameMap.set("DisableDamagePlayer?", "_DisableDamagePlayer");
		_DisableDamagePlayer = false;
		nameMap.set("DisableDamagePlayerNumber", "_DisableDamagePlayerNumber");
		_DisableDamagePlayerNumber = 0.0;
		nameMap.set("Wandering?", "_Wandering");
		_Wandering = false;
		nameMap.set("MaxSpeed", "_MaxSpeed");
		_MaxSpeed = 12.0;
		nameMap.set("RNG", "_RNG");
		_RNG = 0.0;
		nameMap.set("Wander Pixel Limits", "_WanderPixelLimits");
		_WanderPixelLimits = 50.0;
		nameMap.set("Moving?", "_Moving");
		_Moving = false;
		nameMap.set("Shadow", "_Shadow");
		nameMap.set("Die?", "_Die");
		_Die = false;
		nameMap.set("TurningSpeed?", "_TurningSpeed");
		_TurningSpeed = 0.0;
		nameMap.set("OriginalX", "_OriginalX");
		_OriginalX = 0.0;
		nameMap.set("OriginalY", "_OriginalY");
		_OriginalY = 0.0;
		nameMap.set("FirstAlert?", "_FirstAlert");
		_FirstAlert = false;
		nameMap.set("FollowPlayer", "_FollowPlayer");
		_FollowPlayer = false;
		nameMap.set("EnemyAlertThing", "_EnemyAlertThing");
		nameMap.set("StopPlayerFollow", "_StopPlayerFollow");
		_StopPlayerFollow = false;
		nameMap.set("StopFollowPlayerNumb", "_StopFollowPlayerNumb");
		_StopFollowPlayerNumb = 0.0;
		
	}
	
	override public function init()
	{
		
		/* ======================== When Creating ========================= */
		actor.setActorValue("FacingRight?", randomFloat());
		_OriginalX = actor.getXCenter();
		_OriginalY = actor.getYCenter();
		_Wandering = true;
		runPeriodically(1000 * 0.5, function(timeTask:TimedTask):Void
		{
			if(!(_Die))
			{
				if(!(_FollowPlayer))
				{
					if(_Wandering)
					{
						_RNG = randomInt(0, 7);
						if((_RNG >= 6))
						{
							/* "Wander Limits" */ if((actor.getXCenter() >= (_OriginalX + _WanderPixelLimits)))
							{
								_Direction = (180 + randomInt(-45, 45));
							}
							else if((actor.getXCenter() <= (_OriginalX - _WanderPixelLimits)))
							{
								_Direction = (0 + randomInt(-45, 45));
							}
							else if((actor.getYCenter() >= (_OriginalY + _WanderPixelLimits)))
							{
								_Direction = (90 + randomInt(-45, 45));
							}
							else if((actor.getYCenter() <= (_OriginalY - _WanderPixelLimits)))
							{
								_Direction = (-90 + randomInt(-45, 45));
							}
							else
							{
								_Direction = randomInt(0, 360);
							}
							_Moving = true;
						}
						else
						{
							_Moving = false;
						}
					}
				}
			}
		}, actor);
		createRecycledActor(getActorType(7), -500, -500, Script.BACK);
		_Shadow = getLastCreatedActor();
		
		/* ======================== When Creating ========================= */
		/* "Z-Index" */ runPeriodically(1000 * 0.05, function(timeTask:TimedTask):Void
		{
			if(!(_Die))
			{
				for(actorInGroup in cast(getActorGroup(0), Group).list)
				{
					if(actorInGroup != null && !actorInGroup.dead && !actorInGroup.recycled){
						if(((actorInGroup.getY() + ((actorInGroup.getHeight()) - 2)) >= (actor.getY() + (actor.getHeight()))))
						{
							actor.moveToBottom();
						}
						else
						{
							actor.moveToTop();
						}
					}
				}
			}
		}, actor);
		
		/* ======================== When Updating ========================= */
		addWhenUpdatedListener(null, function(elapsedTime:Float, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled)
			{
				if(!(_Die))
				{
					/* "Moving" */ if(_Moving)
					{
						if(!(_FollowPlayer))
						{
							actor.applyImpulseInDirection(_Direction, 1);
						}
					}
					actor.setXVelocity((actor.getXVelocity() * decel));
					actor.setYVelocity((actor.getYVelocity() * decel));
					/* "" */ if(_DisableDamagePlayer)
					{
						_DisableDamagePlayerNumber = (_DisableDamagePlayerNumber + 1);
						if((_DisableDamagePlayerNumber >= 70))
						{
							_DisableDamagePlayer = false;
							_DisableDamagePlayerNumber = 0;
						}
					}
				}
				/* "" */ if(_StopPlayerFollow)
				{
					_StopFollowPlayerNumb = (_StopFollowPlayerNumb + 1);
					if((_StopFollowPlayerNumb >= 35))
					{
						_StopPlayerFollow = false;
					}
				}
				if(_Die)
				{
					actor.setXVelocity((actor.getXVelocity() * 0.95));
					actor.setYVelocity((actor.getYVelocity() * 0.95));
				}
			}
		});
		
		/* ======================== When Updating ========================= */
		addWhenUpdatedListener(null, function(elapsedTime:Float, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled)
			{
				if(!(_Die))
				{
					/* "Animation" */ if(!(_Hit))
					{
						if((((actor.getXVelocity() < 1) && (actor.getXVelocity() > -1)) && ((actor.getYVelocity() < 1) && (actor.getYVelocity() > -1))))
						{
							actor.setAnimation("Idle");
						}
						else
						{
							actor.setAnimation("Run");
						}
					}
					/* "Max Run Speed" */ if((actor.getXVelocity() >= _MaxSpeed))
					{
						actor.setXVelocity(_MaxSpeed);
					}
					else if((actor.getXVelocity() <= -(_MaxSpeed)))
					{
						actor.setXVelocity(-(_MaxSpeed));
					}
					if((actor.getYVelocity() >= _MaxSpeed))
					{
						actor.setYVelocity(_MaxSpeed);
					}
					else if((actor.getYVelocity() <= -(_MaxSpeed)))
					{
						actor.setYVelocity(-(_MaxSpeed));
					}
					/* "Shadow" */ if(_Shadow.isAlive())
					{
						_Shadow.setX((actor.getX() + 5));
						_Shadow.setY((actor.getY() + 19));
					}
					if((hasValue(_EnemyAlertThing)))
					{
						if(_EnemyAlertThing.isAlive())
						{
							_EnemyAlertThing.setX((actor.getXCenter() - 3));
							_EnemyAlertThing.setY((actor.getY() - 10));
						}
					}
					/* "" */ /* "" */ if(!(_Hit))
					{
						if((actor.getXVelocity() >= 1))
						{
							actor.setActorValue("FacingRight?", true);
						}
						else if((actor.getXVelocity() <= -1))
						{
							actor.setActorValue("FacingRight?", false);
						}
					}
					else
					{
						if((actor.getXVelocity() >= 1))
						{
							actor.setActorValue("FacingRight?", false);
						}
						else if((actor.getXVelocity() <= -1))
						{
							actor.setActorValue("FacingRight?", true);
						}
					}
					if((actor.getActorValue("FacingRight?") : Bool))
					{
						actor.growTo(100/100, 100/100, 0, Linear.easeNone);
					}
					else
					{
						actor.growTo(-100/100, 100/100, 0, Linear.easeNone);
					}
				}
			}
		});
		
		/* ======================== When Updating ========================= */
		addWhenUpdatedListener(null, function(elapsedTime:Float, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled)
			{
				if(!(_Die))
				{
					for(actorInGroup in cast(getActorGroup(0), Group).list)
					{
						if(actorInGroup != null && !actorInGroup.dead && !actorInGroup.recycled){
							if(((actor.getXCenter() <= (actorInGroup.getXCenter() + 90)) && ((actor.getXCenter() >= (actorInGroup.getXCenter() - 90)) && ((actor.getYCenter() <= (actorInGroup.getYCenter() + 90)) && (actor.getYCenter() >= (actorInGroup.getYCenter() - 90))))))
							{
								_Wandering = false;
								_FollowPlayer = true;
								_Moving = true;
								if(!(_FirstAlert))
								{
									_FirstAlert = true;
									createRecycledActor(getActorType(45), (actor.getXCenter() - 3), (actor.getY() - 10), Script.FRONT);
									_EnemyAlertThing = getLastCreatedActor();
								}
							}
						}
					}
					if(!(_Wandering))
					{
						if(_FollowPlayer)
						{
							if(!(_Hit))
							{
								if(_Moving)
								{
									if(!(_StopPlayerFollow))
									{
										for(actorInGroup in cast(getActorGroup(0), Group).list)
										{
											if(actorInGroup != null && !actorInGroup.dead && !actorInGroup.recycled){
												_DistanceX = (actorInGroup.getXCenter() - actor.getXCenter());
												_DistanceY = (actorInGroup.getYCenter() - actor.getYCenter());
												_Direction = Utils.DEG * (Math.atan2(_DistanceY, _DistanceX));
												actor.applyImpulseInDirection(_Direction, 1);
												if(((actor.getXCenter() >= (actorInGroup.getXCenter() + 150)) || ((actor.getXCenter() <= (actorInGroup.getXCenter() - 150)) || ((actor.getYCenter() >= (actorInGroup.getYCenter() + 150)) || (actor.getYCenter() <= (actorInGroup.getYCenter() - 150))))))
												{
													_FollowPlayer = false;
													_Moving = false;
													_Wandering = true;
													_FirstAlert = true;
												}
											}
										}
									}
								}
							}
						}
					}
				}
			}
		});
		
		/* ======================= Member of Group ======================== */
		addCollisionListener(actor, function(event:Collision, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled && sameAsAny(getActorGroup(5),event.otherActor.getType(),event.otherActor.getGroup()))
			{
				if(!(_Die))
				{
					if(!(_Hit))
					{
						_Hit = true;
						_Moving = false;
						_Wandering = false;
						_DisableDamagePlayerNumber = 0;
						_DisableDamagePlayer = true;
						_FollowPlayer = false;
						_StopFollowPlayerNumb = 0;
						_StopPlayerFollow = true;
						/* "Damage" */ _HP = (_HP - asNumber(event.otherActor.getActorValue("Damage")));
						/* "" */ setValueForScene("Scene_Setter_", "_SoundName", "Hit1");
						shoutToScene("_customEvent_" + "PlaySoundLimit");
						/* "" */ actor.setAnimation("Hit");
						/* "" */ for(actorInGroup in cast(getActorGroup(0), Group).list)
						{
							if(actorInGroup != null && !actorInGroup.dead && !actorInGroup.recycled){
								actorInGroup.shout("_customEvent_" + "HitEffect1");
							}
						}
						for(index0 in 0...2)
						{
							createRecycledActor(getActorType(21), (actor.getX() + randomInt(0, Std.int(((actor.getWidth()) - 5)))), (actor.getY() + randomInt(0, Std.int(((actor.getHeight()) - 5)))), Script.FRONT);
						}
						createRecycledActor(getActorType(23), (actor.getXCenter() - 29), (actor.getYCenter() - 2), Script.FRONT);
						getLastCreatedActor().shout("_customEvent_" + "Normal1");
						/* "" */ for(actorInGroup in cast(getActorGroup(0), Group).list)
						{
							if(actorInGroup != null && !actorInGroup.dead && !actorInGroup.recycled){
								_DistanceX = (actorInGroup.getXCenter() - actor.getXCenter());
								_DistanceY = (actorInGroup.getYCenter() - actor.getYCenter());
								_Direction = Utils.DEG * (Math.atan2(_DistanceY, _DistanceX));
								actor.applyImpulseInDirection((_Direction + 180), 8);
							}
						}
						runLater(1000 * 0.145, function(timeTask:TimedTask):Void
						{
							if(!(_Die))
							{
								actor.setAnimation("Idle");
							}
						}, actor);
						/* "" */ if((_HP >= 1))
						{
							runLater(1000 * 0.15, function(timeTask:TimedTask):Void
							{
								_Hit = false;
							}, actor);
						}
						else
						{
							_customEvent_Death();
						}
					}
				}
			}
		});
		
		/* ======================= Member of Group ======================== */
		addCollisionListener(actor, function(event:Collision, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled && sameAsAny(getActorGroup(6),event.otherActor.getType(),event.otherActor.getGroup()))
			{
				if(!(_Die))
				{
					if(!(_Hit))
					{
						_Hit = true;
						_Moving = false;
						_Wandering = false;
						_DisableDamagePlayerNumber = 0;
						_DisableDamagePlayer = true;
						_FollowPlayer = false;
						_StopFollowPlayerNumb = 0;
						_StopPlayerFollow = true;
						/* "Damage" */ if(((Engine.engine.getGameAttribute("WhichSword") : String) == "Mage Wand"))
						{
							_HP = (_HP - 2);
						}
						else if(((Engine.engine.getGameAttribute("WhichSword") : String) == "Slayer"))
						{
							_HP = (_HP - 4);
						}
						else if(((Engine.engine.getGameAttribute("WhichSword") : String) == "Goldes"))
						{
							_HP = (_HP - 6);
						}
						/* "" */ setValueForScene("Scene_Setter_", "_SoundName", "Hit1");
						shoutToScene("_customEvent_" + "PlaySoundLimit");
						/* "" */ actor.setAnimation("Hit");
						/* "" */ for(actorInGroup in cast(getActorGroup(0), Group).list)
						{
							if(actorInGroup != null && !actorInGroup.dead && !actorInGroup.recycled){
								actorInGroup.shout("_customEvent_" + "HitEffect1");
							}
						}
						for(index0 in 0...2)
						{
							createRecycledActor(getActorType(21), (actor.getX() + randomInt(0, Std.int(((actor.getWidth()) - 5)))), (actor.getY() + randomInt(0, Std.int(((actor.getHeight()) - 5)))), Script.FRONT);
						}
						createRecycledActor(getActorType(23), (actor.getXCenter() - 29), (actor.getYCenter() - 2), Script.FRONT);
						getLastCreatedActor().shout("_customEvent_" + "Normal1");
						/* "" */ for(actorInGroup in cast(getActorGroup(0), Group).list)
						{
							if(actorInGroup != null && !actorInGroup.dead && !actorInGroup.recycled){
								_DistanceX = (actorInGroup.getXCenter() - actor.getXCenter());
								_DistanceY = (actorInGroup.getYCenter() - actor.getYCenter());
								_Direction = Utils.DEG * (Math.atan2(_DistanceY, _DistanceX));
								actor.applyImpulseInDirection((_Direction + 180), 8);
							}
						}
						runLater(1000 * 0.145, function(timeTask:TimedTask):Void
						{
							if(!(_Die))
							{
								actor.setAnimation("Idle");
							}
						}, actor);
						/* "" */ if((_HP >= 1))
						{
							runLater(1000 * 0.15, function(timeTask:TimedTask):Void
							{
								_Hit = false;
							}, actor);
						}
						else
						{
							_customEvent_Death();
						}
					}
				}
			}
		});
		
		/* ======================= Member of Group ======================== */
		addCollisionListener(actor, function(event:Collision, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled && sameAsAny(getActorGroup(0),event.otherActor.getType(),event.otherActor.getGroup()))
			{
				if(!(_Die))
				{
					if(!(_DisableDamagePlayer))
					{
						if(event.thisFromRight)
						{
							event.otherActor.setActorValue("HitPushDir?", "R");
						}
						else if(event.thisFromLeft)
						{
							event.otherActor.setActorValue("HitPushDir?", "L");
						}
						else if(event.thisFromTop)
						{
							event.otherActor.setActorValue("HitPushDir?", "U");
						}
						else if(event.thisFromBottom)
						{
							event.otherActor.setActorValue("HitPushDir?", "D");
						}
						_StopFollowPlayerNumb = 0;
						_StopPlayerFollow = true;
						event.otherActor.shout("_customEvent_" + "Damage");
					}
				}
			}
		});
		
	}
	
	override public function forwardMessage(msg:String)
	{
		
	}
}