package scripts;

import com.stencyl.graphics.G;
import com.stencyl.graphics.BitmapWrapper;

import com.stencyl.behavior.Script;
import com.stencyl.behavior.Script.*;
import com.stencyl.behavior.ActorScript;
import com.stencyl.behavior.SceneScript;
import com.stencyl.behavior.TimedTask;

import com.stencyl.models.Actor;
import com.stencyl.models.GameModel;
import com.stencyl.models.actor.Animation;
import com.stencyl.models.actor.ActorType;
import com.stencyl.models.actor.Collision;
import com.stencyl.models.actor.Group;
import com.stencyl.models.Scene;
import com.stencyl.models.Sound;
import com.stencyl.models.Region;
import com.stencyl.models.Font;
import com.stencyl.models.Joystick;

import com.stencyl.Engine;
import com.stencyl.Input;
import com.stencyl.Key;
import com.stencyl.utils.Utils;

import openfl.ui.Mouse;
import openfl.display.Graphics;
import openfl.display.BlendMode;
import openfl.display.BitmapData;
import openfl.display.Bitmap;
import openfl.events.Event;
import openfl.events.KeyboardEvent;
import openfl.events.TouchEvent;
import openfl.net.URLLoader;

import box2D.common.math.B2Vec2;
import box2D.dynamics.B2Body;
import box2D.dynamics.B2Fixture;
import box2D.dynamics.joints.B2Joint;

import motion.Actuate;
import motion.easing.Back;
import motion.easing.Cubic;
import motion.easing.Elastic;
import motion.easing.Expo;
import motion.easing.Linear;
import motion.easing.Quad;
import motion.easing.Quart;
import motion.easing.Quint;
import motion.easing.Sine;

import com.stencyl.graphics.shaders.BasicShader;
import com.stencyl.graphics.shaders.GrayscaleShader;
import com.stencyl.graphics.shaders.SepiaShader;
import com.stencyl.graphics.shaders.InvertShader;
import com.stencyl.graphics.shaders.GrainShader;
import com.stencyl.graphics.shaders.ExternalShader;
import com.stencyl.graphics.shaders.InlineShader;
import com.stencyl.graphics.shaders.BlurShader;
import com.stencyl.graphics.shaders.SharpenShader;
import com.stencyl.graphics.shaders.ScanlineShader;
import com.stencyl.graphics.shaders.CSBShader;
import com.stencyl.graphics.shaders.HueShader;
import com.stencyl.graphics.shaders.TintShader;
import com.stencyl.graphics.shaders.BloomShader;



class Design_41_41_Loot extends ActorScript
{
	public var _ScreenDiagonal:Float;
	public var _DistanceX:Float;
	public var _DistanceY:Float;
	public var _Distance:Float;
	public var _Direction:Float;
	public var _MinimumEasingSpeed:Float;
	public var _Speed:Float;
	public var _Margin:Float;
	public var _FastSpeedChanging:Bool;
	public var _FastChangeSpeed:Float;
	public var _Collected:Bool;
	public var _MoveToPlayer:Bool;
	public var _CanBeCollected:Bool;
	public var _LootType:String;
	public var _RNG:Float;
	
	/* ========================= Custom Event ========================= */
	public function _customEvent_Collect():Void
	{
		if(!(_Collected))
		{
			_Collected = true;
			/* "" */ setValueForScene("Scene_Setter_", "_SoundName", "Collect");
			shoutToScene("_customEvent_" + "PlaySoundLimit");
			/* "" */ (Engine.engine.getGameAttribute("InventoryTemp") : Map<String,Dynamic>).set(_LootType, (asNumber((Engine.engine.getGameAttribute("InventoryTemp") : Map<String,Dynamic>).get(_LootType)) + 1));
			for(actorOfType in getActorsOfType(getActorType(54)))
			{
				if(actorOfType != null && !actorOfType.dead && !actorOfType.recycled){
					recycleActor(actorOfType);
				}
			}
			createRecycledActor(getActorType(54), ((getScreenWidth() / 2) - 34), (getScreenHeight() - 19), Script.FRONT);
			getLastCreatedActor().setValue("ActorEvents_54", "_LootText", _LootType);
			actor.growTo(65/100, 140/100, 0, Linear.easeNone);
			actor.growTo(120/100, 65/100, 0.1, Linear.easeNone);
			runLater(1000 * 0.1, function(timeTask:TimedTask):Void
			{
				actor.growTo(30/100, 80/100, 0.1, Linear.easeNone);
				runLater(1000 * 0.1, function(timeTask:TimedTask):Void
				{
					actor.growTo(40/100, 10/100, 0.1, Linear.easeNone);
					runLater(1000 * 0.1, function(timeTask:TimedTask):Void
					{
						actor.growTo(0/100, 30/100, 0.1, Linear.easeNone);
						runLater(1000 * 0.1, function(timeTask:TimedTask):Void
						{
							recycleActor(actor);
						}, actor);
					}, actor);
				}, actor);
			}, actor);
		}
	}
	
	/* ========================= Custom Event ========================= */
	public function _customEvent_Disappear():Void
	{
		actor.disableActorDrawing();
		runLater(1000 * 0.05, function(timeTask:TimedTask):Void
		{
			actor.enableActorDrawing();
			runLater(1000 * 0.05, function(timeTask:TimedTask):Void
			{
				actor.disableActorDrawing();
				runLater(1000 * 0.05, function(timeTask:TimedTask):Void
				{
					actor.enableActorDrawing();
					runLater(1000 * 0.05, function(timeTask:TimedTask):Void
					{
						actor.disableActorDrawing();
						runLater(1000 * 0.05, function(timeTask:TimedTask):Void
						{
							actor.enableActorDrawing();
							runLater(1000 * 0.05, function(timeTask:TimedTask):Void
							{
								if(!(_Collected))
								{
									recycleActor(actor);
								}
							}, actor);
						}, actor);
					}, actor);
				}, actor);
			}, actor);
		}, actor);
	}
	
	/* ========================= Custom Event ========================= */
	public function _customEvent_Enemy_Runner():Void
	{
		_LootType = "Bone";
	}
	
	/* ========================= Custom Event ========================= */
	public function _customEvent_Enemy_Runner2():Void
	{
		_RNG = randomInt(1, 10);
		if((_RNG >= 9))
		{
			_LootType = "Dream Orb";
		}
		else if(((_RNG >= 3) && (_RNG <= 8)))
		{
			_LootType = "Glass Eye";
		}
		else
		{
			_LootType = "Gold Tooth";
		}
	}
	
	/* ========================= Custom Event ========================= */
	public function _customEvent_Enemy_Shooter():Void
	{
		_RNG = randomInt(1, 10);
		if((_RNG >= 7))
		{
			_LootType = "Bone";
		}
		else
		{
			_LootType = "Eye Shard";
		}
	}
	
	/* ========================= Custom Event ========================= */
	public function _customEvent_Enemy_Shooter2():Void
	{
		_RNG = randomInt(1, 10);
		if((_RNG >= 8))
		{
			_LootType = "Despair";
		}
		else if(((_RNG >= 3) && (_RNG <= 7)))
		{
			_LootType = "Glass Eye";
		}
		else
		{
			_LootType = "Eye Shard";
		}
	}
	
	
	public function new(dummy:Int, actor:Actor, dummy2:Engine)
	{
		super(actor);
		nameMap.set("Actor", "actor");
		nameMap.set("Screen Diagonal", "_ScreenDiagonal");
		_ScreenDiagonal = 0.0;
		nameMap.set("Distance X", "_DistanceX");
		_DistanceX = 0.0;
		nameMap.set("Distance Y", "_DistanceY");
		_DistanceY = 0.0;
		nameMap.set("Distance", "_Distance");
		_Distance = 0.0;
		nameMap.set("Direction", "_Direction");
		_Direction = 0.0;
		nameMap.set("Minimum Easing Speed", "_MinimumEasingSpeed");
		_MinimumEasingSpeed = 5.0;
		nameMap.set("Speed", "_Speed");
		_Speed = 30.0;
		nameMap.set("Margin", "_Margin");
		_Margin = 0.0;
		nameMap.set("FastSpeedChanging?", "_FastSpeedChanging");
		_FastSpeedChanging = false;
		nameMap.set("FastChangeSpeed?", "_FastChangeSpeed");
		_FastChangeSpeed = 0.0;
		nameMap.set("Collected?", "_Collected");
		_Collected = false;
		nameMap.set("MoveToPlayer?", "_MoveToPlayer");
		_MoveToPlayer = false;
		nameMap.set("CanBeCollected?", "_CanBeCollected");
		_CanBeCollected = false;
		nameMap.set("LootType", "_LootType");
		_LootType = "";
		nameMap.set("RNG", "_RNG");
		_RNG = 0.0;
		
	}
	
	override public function init()
	{
		
		/* ======================== When Creating ========================= */
		runLater(1000 * 10, function(timeTask:TimedTask):Void
		{
			if((!(_MoveToPlayer) && !(_Collected)))
			{
				_customEvent_Disappear();
			}
		}, actor);
		runLater(1000 * 0.3, function(timeTask:TimedTask):Void
		{
			_CanBeCollected = true;
		}, actor);
		actor.moveToLayer(engine.getLayerByName("Above"));
		actor.spinBy(randomInt(-10, 10), randomFloatBetween(0.2, 0.4), Linear.easeNone);
		actor.setVelocity(randomInt(0, 360), randomInt(3, 10));
		_ScreenDiagonal = Math.sqrt((Math.pow(getScreenWidth(), 2) + Math.pow(getScreenHeight(), 2)));
		
		/* ======================== When Updating ========================= */
		addWhenUpdatedListener(null, function(elapsedTime:Float, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled)
			{
				if(!(_MoveToPlayer))
				{
					actor.setXVelocity((actor.getXVelocity() * 0.9));
					actor.setYVelocity((actor.getYVelocity() * 0.9));
					if(_CanBeCollected)
					{
						for(actorInGroup in cast(getActorGroup(0), Group).list)
						{
							if(actorInGroup != null && !actorInGroup.dead && !actorInGroup.recycled){
								if(((actor.getXCenter() >= (actorInGroup.getXCenter() - 32)) && ((actor.getXCenter() <= (actorInGroup.getXCenter() + 32)) && ((actor.getYCenter() >= (actorInGroup.getYCenter() - 32)) && (actor.getYCenter() <= (actorInGroup.getYCenter() + 32))))))
								{
									_MoveToPlayer = true;
								}
							}
						}
					}
				}
				else
				{
					for(actorOfType in getActorsOfType(getActorType(0)))
					{
						if(actorOfType != null && !actorOfType.dead && !actorOfType.recycled){
							_DistanceX = (actorOfType.getXCenter() - actor.getXCenter());
							_DistanceY = (actorOfType.getYCenter() - actor.getYCenter());
							_Distance = asNumber(Math.sqrt((Math.pow(_DistanceX, 2) + Math.pow(_DistanceY, 2))));
							_Direction = Utils.DEG * (Math.atan2(_DistanceY, _DistanceX));
							if((_Distance >= 5))
							{
								if(!(_FastSpeedChanging))
								{
									if(!((actor.getActorValue("ModifiedCam?") : Bool)))
									{
										actor.setVelocity(_Direction, (_MinimumEasingSpeed + (_Speed * ((_Distance - _Margin) / _ScreenDiagonal))));
									}
									else
									{
										actor.setVelocity(_Direction, (_MinimumEasingSpeed + (asNumber(actor.getActorValue("ModifiedCamSpeed?")) * ((_Distance - _Margin) / _ScreenDiagonal))));
									}
								}
								else
								{
									actor.setVelocity(_Direction, (_MinimumEasingSpeed + (_FastChangeSpeed * ((_Distance - _Margin) / _ScreenDiagonal))));
								}
							}
							else
							{
								actor.setVelocity(0, 0);
								_customEvent_Collect();
							}
						}
					}
				}
			}
		});
		
	}
	
	override public function forwardMessage(msg:String)
	{
		
	}
}