package scripts;

import com.stencyl.graphics.G;
import com.stencyl.graphics.BitmapWrapper;

import com.stencyl.behavior.Script;
import com.stencyl.behavior.Script.*;
import com.stencyl.behavior.ActorScript;
import com.stencyl.behavior.SceneScript;
import com.stencyl.behavior.TimedTask;

import com.stencyl.models.Actor;
import com.stencyl.models.GameModel;
import com.stencyl.models.actor.Animation;
import com.stencyl.models.actor.ActorType;
import com.stencyl.models.actor.Collision;
import com.stencyl.models.actor.Group;
import com.stencyl.models.Scene;
import com.stencyl.models.Sound;
import com.stencyl.models.Region;
import com.stencyl.models.Font;
import com.stencyl.models.Joystick;

import com.stencyl.Engine;
import com.stencyl.Input;
import com.stencyl.Key;
import com.stencyl.utils.Utils;

import openfl.ui.Mouse;
import openfl.display.Graphics;
import openfl.display.BlendMode;
import openfl.display.BitmapData;
import openfl.display.Bitmap;
import openfl.events.Event;
import openfl.events.KeyboardEvent;
import openfl.events.TouchEvent;
import openfl.net.URLLoader;

import box2D.common.math.B2Vec2;
import box2D.dynamics.B2Body;
import box2D.dynamics.B2Fixture;
import box2D.dynamics.joints.B2Joint;

import motion.Actuate;
import motion.easing.Back;
import motion.easing.Cubic;
import motion.easing.Elastic;
import motion.easing.Expo;
import motion.easing.Linear;
import motion.easing.Quad;
import motion.easing.Quart;
import motion.easing.Quint;
import motion.easing.Sine;

import com.stencyl.graphics.shaders.BasicShader;
import com.stencyl.graphics.shaders.GrayscaleShader;
import com.stencyl.graphics.shaders.SepiaShader;
import com.stencyl.graphics.shaders.InvertShader;
import com.stencyl.graphics.shaders.GrainShader;
import com.stencyl.graphics.shaders.ExternalShader;
import com.stencyl.graphics.shaders.InlineShader;
import com.stencyl.graphics.shaders.BlurShader;
import com.stencyl.graphics.shaders.SharpenShader;
import com.stencyl.graphics.shaders.ScanlineShader;
import com.stencyl.graphics.shaders.CSBShader;
import com.stencyl.graphics.shaders.HueShader;
import com.stencyl.graphics.shaders.TintShader;
import com.stencyl.graphics.shaders.BloomShader;



class Design_57_57_StoreItem extends ActorScript
{
	public var _Touching:Float;
	public var _Touch:Bool;
	public var _WhichStoreItem:Float;
	public var _SpawnedS:Bool;
	public var _StorePressActor:Actor;
	public var _CurrentStoreItem:String;
	public var _RNG:Float;
	
	/* ========================= Custom Event ========================= */
	public function _customEvent_SetGlobal():Void
	{
		if((_WhichStoreItem == 1))
		{
			Engine.engine.setGameAttribute("StoreItem1", _CurrentStoreItem);
		}
		else if((_WhichStoreItem == 2))
		{
			Engine.engine.setGameAttribute("StoreItem2", _CurrentStoreItem);
		}
		else if((_WhichStoreItem == 3))
		{
			Engine.engine.setGameAttribute("StoreItem3", _CurrentStoreItem);
		}
		else if((_WhichStoreItem == 4))
		{
			Engine.engine.setGameAttribute("StoreItem4", _CurrentStoreItem);
		}
	}
	
	
	public function new(dummy:Int, actor:Actor, dummy2:Engine)
	{
		super(actor);
		nameMap.set("Actor", "actor");
		nameMap.set("Touching?", "_Touching");
		_Touching = 0.0;
		nameMap.set("Touch", "_Touch");
		_Touch = false;
		nameMap.set("WhichStoreItem", "_WhichStoreItem");
		_WhichStoreItem = 0.0;
		nameMap.set("SpawnedS", "_SpawnedS");
		_SpawnedS = false;
		nameMap.set("StorePressActor", "_StorePressActor");
		nameMap.set("CurrentStoreItem?", "_CurrentStoreItem");
		_CurrentStoreItem = "";
		nameMap.set("RNG", "_RNG");
		_RNG = 0.0;
		
	}
	
	override public function init()
	{
		
		/* ======================== When Creating ========================= */
		_Touching = 1000;
		_Touch = false;
		if((_WhichStoreItem == 1))
		{
			_CurrentStoreItem = (Engine.engine.getGameAttribute("StoreItem1") : String);
		}
		else if((_WhichStoreItem == 2))
		{
			_CurrentStoreItem = (Engine.engine.getGameAttribute("StoreItem2") : String);
		}
		else if((_WhichStoreItem == 3))
		{
			_CurrentStoreItem = (Engine.engine.getGameAttribute("StoreItem3") : String);
		}
		else if((_WhichStoreItem == 4))
		{
			_CurrentStoreItem = (Engine.engine.getGameAttribute("StoreItem4") : String);
		}
		/* "" */ if((_CurrentStoreItem == "None"))
		{
			actor.setAnimation("Normal");
		}
		else
		{
			actor.setAnimation("On");
		}
		/* "" */ runPeriodically(1000 * 0.3, function(timeTask:TimedTask):Void
		{
			runLater(1000 * randomFloatBetween(0, 0.15), function(timeTask:TimedTask):Void
			{
				if((asNumber((Engine.engine.getGameAttribute("Inventory") : Map<String,Dynamic>).get(_CurrentStoreItem)) >= 1))
				{
					if((_CurrentStoreItem == "Bone"))
					{
						/* "" */ _RNG = randomInt(1, 20);
						if((_RNG >= 18))
						{
							(Engine.engine.getGameAttribute("Inventory") : Map<String,Dynamic>).set(_CurrentStoreItem, (asNumber((Engine.engine.getGameAttribute("Inventory") : Map<String,Dynamic>).get(_CurrentStoreItem)) - 1));
							Engine.engine.setGameAttribute("Souls", ((Engine.engine.getGameAttribute("Souls") : Float) + 3));
							for(actorOfType in getActorsOfType(getActorType(31)))
							{
								if(actorOfType != null && !actorOfType.dead && !actorOfType.recycled){
									createRecycledActor(getActorType(86), ((actorOfType.getXCenter() - 8) + randomInt(-32, 32)), ((actorOfType.getYCenter() + 10) + randomInt(0, 8)), Script.FRONT);
									getLastCreatedActor().setValue("ActorEvents_86", "_SoulAmount", 3);
								}
							}
							if((asNumber((Engine.engine.getGameAttribute("Inventory") : Map<String,Dynamic>).get(_CurrentStoreItem)) <= 0))
							{
								actor.setAnimation("Normal");
								_CurrentStoreItem = "None";
								_customEvent_SetGlobal();
							}
						}
					}
					if((_CurrentStoreItem == "Eye Shard"))
					{
						/* "" */ _RNG = randomInt(1, 30);
						if((_RNG >= 27))
						{
							(Engine.engine.getGameAttribute("Inventory") : Map<String,Dynamic>).set(_CurrentStoreItem, (asNumber((Engine.engine.getGameAttribute("Inventory") : Map<String,Dynamic>).get(_CurrentStoreItem)) - 1));
							Engine.engine.setGameAttribute("Souls", ((Engine.engine.getGameAttribute("Souls") : Float) + 6));
							for(actorOfType in getActorsOfType(getActorType(31)))
							{
								if(actorOfType != null && !actorOfType.dead && !actorOfType.recycled){
									createRecycledActor(getActorType(86), ((actorOfType.getXCenter() - 8) + randomInt(-32, 32)), ((actorOfType.getYCenter() + 10) + randomInt(0, 8)), Script.FRONT);
									getLastCreatedActor().setValue("ActorEvents_86", "_SoulAmount", 6);
								}
							}
							if((asNumber((Engine.engine.getGameAttribute("Inventory") : Map<String,Dynamic>).get(_CurrentStoreItem)) <= 0))
							{
								actor.setAnimation("Normal");
								_CurrentStoreItem = "None";
								_customEvent_SetGlobal();
							}
						}
					}
					if((_CurrentStoreItem == "Glass Eye"))
					{
						/* "" */ _RNG = randomInt(1, 50);
						if((_RNG >= 40))
						{
							(Engine.engine.getGameAttribute("Inventory") : Map<String,Dynamic>).set(_CurrentStoreItem, (asNumber((Engine.engine.getGameAttribute("Inventory") : Map<String,Dynamic>).get(_CurrentStoreItem)) - 1));
							Engine.engine.setGameAttribute("Souls", ((Engine.engine.getGameAttribute("Souls") : Float) + 15));
							for(actorOfType in getActorsOfType(getActorType(31)))
							{
								if(actorOfType != null && !actorOfType.dead && !actorOfType.recycled){
									createRecycledActor(getActorType(86), ((actorOfType.getXCenter() - 8) + randomInt(-32, 32)), ((actorOfType.getYCenter() + 10) + randomInt(0, 8)), Script.FRONT);
									getLastCreatedActor().setValue("ActorEvents_86", "_SoulAmount", 15);
								}
							}
							if((asNumber((Engine.engine.getGameAttribute("Inventory") : Map<String,Dynamic>).get(_CurrentStoreItem)) <= 0))
							{
								actor.setAnimation("Normal");
								_CurrentStoreItem = "None";
								_customEvent_SetGlobal();
							}
						}
					}
					if((_CurrentStoreItem == "Gold Tooth"))
					{
						/* "" */ _RNG = randomInt(1, 80);
						if((_RNG >= 75))
						{
							(Engine.engine.getGameAttribute("Inventory") : Map<String,Dynamic>).set(_CurrentStoreItem, (asNumber((Engine.engine.getGameAttribute("Inventory") : Map<String,Dynamic>).get(_CurrentStoreItem)) - 1));
							Engine.engine.setGameAttribute("Souls", ((Engine.engine.getGameAttribute("Souls") : Float) + 40));
							for(actorOfType in getActorsOfType(getActorType(31)))
							{
								if(actorOfType != null && !actorOfType.dead && !actorOfType.recycled){
									createRecycledActor(getActorType(86), ((actorOfType.getXCenter() - 8) + randomInt(-32, 32)), ((actorOfType.getYCenter() + 10) + randomInt(0, 8)), Script.FRONT);
									getLastCreatedActor().setValue("ActorEvents_86", "_SoulAmount", 40);
								}
							}
							if((asNumber((Engine.engine.getGameAttribute("Inventory") : Map<String,Dynamic>).get(_CurrentStoreItem)) <= 0))
							{
								actor.setAnimation("Normal");
								_CurrentStoreItem = "None";
								_customEvent_SetGlobal();
							}
						}
					}
					if((_CurrentStoreItem == "Despair"))
					{
						/* "" */ _RNG = randomInt(1, 100);
						if((_RNG >= 95))
						{
							(Engine.engine.getGameAttribute("Inventory") : Map<String,Dynamic>).set(_CurrentStoreItem, (asNumber((Engine.engine.getGameAttribute("Inventory") : Map<String,Dynamic>).get(_CurrentStoreItem)) - 1));
							Engine.engine.setGameAttribute("Souls", ((Engine.engine.getGameAttribute("Souls") : Float) + 100));
							for(actorOfType in getActorsOfType(getActorType(31)))
							{
								if(actorOfType != null && !actorOfType.dead && !actorOfType.recycled){
									createRecycledActor(getActorType(86), ((actorOfType.getXCenter() - 8) + randomInt(-32, 32)), ((actorOfType.getYCenter() + 10) + randomInt(0, 8)), Script.FRONT);
									getLastCreatedActor().setValue("ActorEvents_86", "_SoulAmount", 100);
								}
							}
							if((asNumber((Engine.engine.getGameAttribute("Inventory") : Map<String,Dynamic>).get(_CurrentStoreItem)) <= 0))
							{
								actor.setAnimation("Normal");
								_CurrentStoreItem = "None";
								_customEvent_SetGlobal();
							}
						}
					}
					if((_CurrentStoreItem == "Dream Orb"))
					{
						/* "" */ _RNG = randomInt(1, 150);
						if((_RNG >= 145))
						{
							(Engine.engine.getGameAttribute("Inventory") : Map<String,Dynamic>).set(_CurrentStoreItem, (asNumber((Engine.engine.getGameAttribute("Inventory") : Map<String,Dynamic>).get(_CurrentStoreItem)) - 1));
							Engine.engine.setGameAttribute("Souls", ((Engine.engine.getGameAttribute("Souls") : Float) + 200));
							for(actorOfType in getActorsOfType(getActorType(31)))
							{
								if(actorOfType != null && !actorOfType.dead && !actorOfType.recycled){
									createRecycledActor(getActorType(86), ((actorOfType.getXCenter() - 8) + randomInt(-32, 32)), ((actorOfType.getYCenter() + 10) + randomInt(0, 8)), Script.FRONT);
									getLastCreatedActor().setValue("ActorEvents_86", "_SoulAmount", 200);
								}
							}
							if((asNumber((Engine.engine.getGameAttribute("Inventory") : Map<String,Dynamic>).get(_CurrentStoreItem)) <= 0))
							{
								actor.setAnimation("Normal");
								_CurrentStoreItem = "None";
								_customEvent_SetGlobal();
							}
						}
					}
				}
				else
				{
					actor.setAnimation("Normal");
					_CurrentStoreItem = "None";
				}
			}, actor);
		}, actor);
		
		/* ======================== When Updating ========================= */
		addWhenUpdatedListener(null, function(elapsedTime:Float, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled)
			{
				for(actorInGroup in cast(getActorGroup(0), Group).list)
				{
					if(actorInGroup != null && !actorInGroup.dead && !actorInGroup.recycled){
						if(((actorInGroup.getXCenter() <= (actor.getX() + (actor.getWidth()))) && ((actorInGroup.getXCenter() >= actor.getX()) && ((actorInGroup.getYCenter() <= (actor.getY() + (actor.getHeight()))) && (actorInGroup.getYCenter() >= actor.getY())))))
						{
							if(_Touch)
							{
								if(!(_SpawnedS))
								{
									_SpawnedS = true;
									createRecycledActor(getActorType(80), (actor.getXCenter() - 6), (actor.getY() - 4), Script.FRONT);
									_StorePressActor = getLastCreatedActor();
								}
							}
							_Touch = true;
						}
						else
						{
							_Touch = false;
							if(_SpawnedS)
							{
								_SpawnedS = false;
								if(_StorePressActor.isAlive())
								{
									recycleActor(_StorePressActor);
								}
							}
						}
					}
				}
				/* "" */ if(isKeyPressed("Attack"))
				{
					if(_Touch)
					{
						if(!((Engine.engine.getGameAttribute("UsingPersonalStore") : Bool)))
						{
							for(actorInGroup in cast(getActorGroup(0), Group).list)
							{
								if(actorInGroup != null && !actorInGroup.dead && !actorInGroup.recycled){
									if(!((actorInGroup.getActorValue("Die?") : Bool)))
									{
										Engine.engine.setGameAttribute("UsingPersonalStore", true);
										actorInGroup.setActorValue("UsingStore?", true);
										createRecycledActor(getActorType(84), 100, 45, Script.FRONT);
										createRecycledActor(getActorType(78), 47, 64, Script.FRONT);
										getLastCreatedActor().setValue("ActorEvents_78", "_WhichItem", "Bone");
										getLastCreatedActor().setValue("ActorEvents_78", "_WhichStoreSpace", _WhichStoreItem);
										createRecycledActor(getActorType(78), 109, 64, Script.FRONT);
										getLastCreatedActor().setValue("ActorEvents_78", "_WhichItem", "Eye Shard");
										getLastCreatedActor().setValue("ActorEvents_78", "_WhichStoreSpace", _WhichStoreItem);
										createRecycledActor(getActorType(78), 171, 64, Script.FRONT);
										getLastCreatedActor().setValue("ActorEvents_78", "_WhichItem", "Glass Eye");
										getLastCreatedActor().setValue("ActorEvents_78", "_WhichStoreSpace", _WhichStoreItem);
										createRecycledActor(getActorType(78), 47, 96, Script.FRONT);
										getLastCreatedActor().setValue("ActorEvents_78", "_WhichItem", "Gold Tooth");
										getLastCreatedActor().setValue("ActorEvents_78", "_WhichStoreSpace", _WhichStoreItem);
										createRecycledActor(getActorType(78), 109, 96, Script.FRONT);
										getLastCreatedActor().setValue("ActorEvents_78", "_WhichItem", "Despair");
										getLastCreatedActor().setValue("ActorEvents_78", "_WhichStoreSpace", _WhichStoreItem);
										createRecycledActor(getActorType(78), 171, 96, Script.FRONT);
										getLastCreatedActor().setValue("ActorEvents_78", "_WhichItem", "Dream Orb");
										getLastCreatedActor().setValue("ActorEvents_78", "_WhichStoreSpace", _WhichStoreItem);
										createRecycledActor(getActorType(82), 114, 128, Script.FRONT);
									}
								}
							}
						}
					}
				}
			}
		});
		
	}
	
	override public function forwardMessage(msg:String)
	{
		
	}
}