package scripts;

import com.stencyl.graphics.G;
import com.stencyl.graphics.BitmapWrapper;

import com.stencyl.behavior.Script;
import com.stencyl.behavior.Script.*;
import com.stencyl.behavior.ActorScript;
import com.stencyl.behavior.SceneScript;
import com.stencyl.behavior.TimedTask;

import com.stencyl.models.Actor;
import com.stencyl.models.GameModel;
import com.stencyl.models.actor.Animation;
import com.stencyl.models.actor.ActorType;
import com.stencyl.models.actor.Collision;
import com.stencyl.models.actor.Group;
import com.stencyl.models.Scene;
import com.stencyl.models.Sound;
import com.stencyl.models.Region;
import com.stencyl.models.Font;
import com.stencyl.models.Joystick;

import com.stencyl.Engine;
import com.stencyl.Input;
import com.stencyl.Key;
import com.stencyl.utils.Utils;

import openfl.ui.Mouse;
import openfl.display.Graphics;
import openfl.display.BlendMode;
import openfl.display.BitmapData;
import openfl.display.Bitmap;
import openfl.events.Event;
import openfl.events.KeyboardEvent;
import openfl.events.TouchEvent;
import openfl.net.URLLoader;

import box2D.common.math.B2Vec2;
import box2D.dynamics.B2Body;
import box2D.dynamics.B2Fixture;
import box2D.dynamics.joints.B2Joint;

import motion.Actuate;
import motion.easing.Back;
import motion.easing.Cubic;
import motion.easing.Elastic;
import motion.easing.Expo;
import motion.easing.Linear;
import motion.easing.Quad;
import motion.easing.Quart;
import motion.easing.Quint;
import motion.easing.Sine;

import com.stencyl.graphics.shaders.BasicShader;
import com.stencyl.graphics.shaders.GrayscaleShader;
import com.stencyl.graphics.shaders.SepiaShader;
import com.stencyl.graphics.shaders.InvertShader;
import com.stencyl.graphics.shaders.GrainShader;
import com.stencyl.graphics.shaders.ExternalShader;
import com.stencyl.graphics.shaders.InlineShader;
import com.stencyl.graphics.shaders.BlurShader;
import com.stencyl.graphics.shaders.SharpenShader;
import com.stencyl.graphics.shaders.ScanlineShader;
import com.stencyl.graphics.shaders.CSBShader;
import com.stencyl.graphics.shaders.HueShader;
import com.stencyl.graphics.shaders.TintShader;
import com.stencyl.graphics.shaders.BloomShader;



class Design_65_65_StoreWeapons extends ActorScript
{
	public var _Touch:Bool;
	public var _SpawnedS:Bool;
	public var _BorderBox:Actor;
	public var _WhichSword:String;
	public var _Cost:Float;
	
	
	public function new(dummy:Int, actor:Actor, dummy2:Engine)
	{
		super(actor);
		nameMap.set("Actor", "actor");
		nameMap.set("Touch", "_Touch");
		_Touch = false;
		nameMap.set("SpawnedS", "_SpawnedS");
		_SpawnedS = false;
		nameMap.set("BorderBox", "_BorderBox");
		nameMap.set("WhichSword?", "_WhichSword");
		_WhichSword = "";
		nameMap.set("Cost", "_Cost");
		_Cost = 0.0;
		
	}
	
	override public function init()
	{
		
		/* ======================== When Creating ========================= */
		if((_WhichSword == "Heart"))
		{
			actor.setAnimation("Heart");
		}
		if((asNumber((Engine.engine.getGameAttribute("Swords") : Map<String,Dynamic>).get(_WhichSword)) >= 1))
		{
			actor.setAnimation("Open");
		}
		
		/* ======================== When Updating ========================= */
		addWhenUpdatedListener(null, function(elapsedTime:Float, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled)
			{
				for(actorInGroup in cast(getActorGroup(0), Group).list)
				{
					if(actorInGroup != null && !actorInGroup.dead && !actorInGroup.recycled){
						if(((actorInGroup.getXCenter() <= (actor.getX() + (actor.getWidth()))) && ((actorInGroup.getXCenter() >= actor.getX()) && ((actorInGroup.getYCenter() <= (actor.getY() + (actor.getHeight()))) && (actorInGroup.getYCenter() >= actor.getY())))))
						{
							_Touch = true;
							if(!(_SpawnedS))
							{
								_SpawnedS = true;
								createRecycledActor(getActorType(92), ((getScreenWidth() / 2) - 56), 40, Script.FRONT);
								_BorderBox = getLastCreatedActor();
								getLastCreatedActor().setValue("ActorEvents_92", "_WhichWeapon", _WhichSword);
								getLastCreatedActor().setValue("ActorEvents_92", "_Cost", _Cost);
							}
						}
						else
						{
							_Touch = false;
							if(_SpawnedS)
							{
								_SpawnedS = false;
								if(_BorderBox.isAlive())
								{
									recycleActor(_BorderBox);
								}
							}
						}
					}
				}
				/* "" */ if(isKeyPressed("Attack"))
				{
					if(_Touch)
					{
						if(!(_WhichSword == "Heart"))
						{
							if((asNumber((Engine.engine.getGameAttribute("Swords") : Map<String,Dynamic>).get(_WhichSword)) >= 1))
							{
								Engine.engine.setGameAttribute("WhichSword", _WhichSword);
								playSound(getSound(140));
								for(actorOfType in getActorsOfType(getActorType(5)))
								{
									if(actorOfType != null && !actorOfType.dead && !actorOfType.recycled){
										actorOfType.shout("_customEvent_" + "Switch");
									}
								}
							}
							else
							{
								if(((Engine.engine.getGameAttribute("Souls") : Float) >= _Cost))
								{
									Engine.engine.setGameAttribute("Souls", ((Engine.engine.getGameAttribute("Souls") : Float) - _Cost));
									actor.setAnimation("Open");
									playSound(getSound(140));
									/* "" */ (Engine.engine.getGameAttribute("Swords") : Map<String,Dynamic>).set(_WhichSword, 1);
									Engine.engine.setGameAttribute("WhichSword", _WhichSword);
									for(actorOfType in getActorsOfType(getActorType(5)))
									{
										if(actorOfType != null && !actorOfType.dead && !actorOfType.recycled){
											actorOfType.shout("_customEvent_" + "Switch");
										}
									}
								}
							}
						}
						else
						{
							if(((Engine.engine.getGameAttribute("Hearts") : Float) <= 2))
							{
								if(((Engine.engine.getGameAttribute("Souls") : Float) >= _Cost))
								{
									playSound(getSound(140));
									Engine.engine.setGameAttribute("Souls", ((Engine.engine.getGameAttribute("Souls") : Float) - _Cost));
									/* "" */ Engine.engine.setGameAttribute("Hearts", ((Engine.engine.getGameAttribute("Hearts") : Float) + 1));
								}
							}
						}
					}
				}
			}
		});
		
	}
	
	override public function forwardMessage(msg:String)
	{
		
	}
}