package scripts;

import com.stencyl.graphics.G;
import com.stencyl.graphics.BitmapWrapper;

import com.stencyl.behavior.Script;
import com.stencyl.behavior.Script.*;
import com.stencyl.behavior.ActorScript;
import com.stencyl.behavior.SceneScript;
import com.stencyl.behavior.TimedTask;

import com.stencyl.models.Actor;
import com.stencyl.models.GameModel;
import com.stencyl.models.actor.Animation;
import com.stencyl.models.actor.ActorType;
import com.stencyl.models.actor.Collision;
import com.stencyl.models.actor.Group;
import com.stencyl.models.Scene;
import com.stencyl.models.Sound;
import com.stencyl.models.Region;
import com.stencyl.models.Font;
import com.stencyl.models.Joystick;

import com.stencyl.Engine;
import com.stencyl.Input;
import com.stencyl.Key;
import com.stencyl.utils.Utils;

import openfl.ui.Mouse;
import openfl.display.Graphics;
import openfl.display.BlendMode;
import openfl.display.BitmapData;
import openfl.display.Bitmap;
import openfl.events.Event;
import openfl.events.KeyboardEvent;
import openfl.events.TouchEvent;
import openfl.net.URLLoader;

import box2D.common.math.B2Vec2;
import box2D.dynamics.B2Body;
import box2D.dynamics.B2Fixture;
import box2D.dynamics.joints.B2Joint;

import motion.Actuate;
import motion.easing.Back;
import motion.easing.Cubic;
import motion.easing.Elastic;
import motion.easing.Expo;
import motion.easing.Linear;
import motion.easing.Quad;
import motion.easing.Quart;
import motion.easing.Quint;
import motion.easing.Sine;

import com.stencyl.graphics.shaders.BasicShader;
import com.stencyl.graphics.shaders.GrayscaleShader;
import com.stencyl.graphics.shaders.SepiaShader;
import com.stencyl.graphics.shaders.InvertShader;
import com.stencyl.graphics.shaders.GrainShader;
import com.stencyl.graphics.shaders.ExternalShader;
import com.stencyl.graphics.shaders.InlineShader;
import com.stencyl.graphics.shaders.BlurShader;
import com.stencyl.graphics.shaders.SharpenShader;
import com.stencyl.graphics.shaders.ScanlineShader;
import com.stencyl.graphics.shaders.CSBShader;
import com.stencyl.graphics.shaders.HueShader;
import com.stencyl.graphics.shaders.TintShader;
import com.stencyl.graphics.shaders.BloomShader;



class Design_7_7_PlayerSword extends ActorScript
{
	public var _Sword:Actor;
	public var _AttackMode:Bool;
	public var _AttackModeNumber:Float;
	public var _AttackPushForce:Float;
	
	/* ========================= Custom Event ========================= */
	public function _customEvent_HitEffect1():Void
	{
		startShakingScreen(0.2 / 100, 0.1);
		runLater(1000 * 0.1, function(timeTask:TimedTask):Void
		{
			startShakingScreen(0.1 / 100, 0.05);
		}, actor);
	}
	
	
	public function new(dummy:Int, actor:Actor, dummy2:Engine)
	{
		super(actor);
		nameMap.set("Actor", "actor");
		nameMap.set("Sword", "_Sword");
		nameMap.set("AttackMode?", "_AttackMode");
		_AttackMode = false;
		nameMap.set("AttackModeNumber", "_AttackModeNumber");
		_AttackModeNumber = 0.0;
		nameMap.set("AttackPushForce", "_AttackPushForce");
		_AttackPushForce = 0.0;
		
	}
	
	override public function init()
	{
		
		/* ======================== When Creating ========================= */
		_AttackPushForce = 3;
		actor.setActorValue("Attacking?", false);
		actor.setActorValue("AttackDirection?", "R");
		createRecycledActor(getActorType(5), -500, -500, Script.BACK);
		getLastCreatedActor().moveToLayer(engine.getLayerById(actor.getLayerID()));
		getLastCreatedActor().moveToBottom();
		_Sword = getLastCreatedActor();
		getLastCreatedActor().setAnimation((Engine.engine.getGameAttribute("WhichSword") : String));
		if((Engine.engine.getGameAttribute("FirstSpawn") : Bool))
		{
			for(actorOfType in getActorsOfType(getActorType(5)))
			{
				if(actorOfType != null && !actorOfType.dead && !actorOfType.recycled){
					actorOfType.disableActorDrawing();
				}
			}
		}
		
		/* ======================== When Updating ========================= */
		addWhenUpdatedListener(null, function(elapsedTime:Float, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled)
			{
				if(!((actor.getActorValue("Die?") : Bool)))
				{
					if(_Sword.isAlive())
					{
						if((actor.getActorValue("FacingRight?") : Bool))
						{
							if(_AttackMode)
							{
								if((actor.getActorValue("Attacking?") : Bool))
								{
									/* Center Sword */
									_Sword.setX((actor.getX() + 4));
									_Sword.setY((actor.getY() + -19));
								}
								else
								{
									/* Keep to the side */
									_Sword.setX((actor.getX() + 0));
									_Sword.setY((actor.getY() + -17));
									_Sword.setAngle(Utils.RAD * (-30));
								}
							}
							else
							{
								_Sword.setX((actor.getX() + 6));
								_Sword.setY((actor.getY() + -18));
								_Sword.setAngle(Utils.RAD * (-30));
							}
						}
						else
						{
							if(_AttackMode)
							{
								if((actor.getActorValue("Attacking?") : Bool))
								{
									/* Center Sword */
									_Sword.setX((actor.getX() + 2));
									_Sword.setY((actor.getY() + -19));
								}
								else
								{
									/* Keep to the side */
									_Sword.setX((actor.getX() + 4));
									_Sword.setY((actor.getY() + -17));
									_Sword.setAngle(Utils.RAD * (30));
								}
							}
							else
							{
								_Sword.setX((actor.getX() + -2));
								_Sword.setY((actor.getY() + -18));
								_Sword.setAngle(Utils.RAD * (30));
							}
						}
					}
				}
			}
		});
		
		/* ======================== When Updating ========================= */
		addWhenUpdatedListener(null, function(elapsedTime:Float, list:Array<Dynamic>):Void
		{
			if(wrapper.enabled)
			{
				if(!((actor.getActorValue("UsingStore?") : Bool)))
				{
					if(!((actor.getActorValue("Die?") : Bool)))
					{
						/* "" */ if(!((actor.getActorValue("AnalogStickMove?") : Bool)))
						{
							if(((isKeyDown("right") && !(isKeyDown("up"))) && !(isKeyDown("down"))))
							{
								actor.setActorValue("AttackDirection?", "R");
							}
							else if((isKeyDown("right") && isKeyDown("up")))
							{
								actor.setActorValue("AttackDirection?", "RU");
							}
							else if(((isKeyDown("up") && !(isKeyDown("left"))) && !(isKeyDown("right"))))
							{
								actor.setActorValue("AttackDirection?", "U");
							}
							else if((isKeyDown("left") && isKeyDown("up")))
							{
								actor.setActorValue("AttackDirection?", "LU");
							}
							else if(((isKeyDown("left") && !(isKeyDown("up"))) && !(isKeyDown("down"))))
							{
								actor.setActorValue("AttackDirection?", "L");
							}
							else if((isKeyDown("left") && isKeyDown("down")))
							{
								actor.setActorValue("AttackDirection?", "LD");
							}
							else if(((isKeyDown("down") && !(isKeyDown("left"))) && !(isKeyDown("right"))))
							{
								actor.setActorValue("AttackDirection?", "D");
							}
							else if((isKeyDown("right") && isKeyDown("down")))
							{
								actor.setActorValue("AttackDirection?", "RD");
							}
						}
						else
						{
							if((((asNumber(getValueForScene("Scene_Setter_", "_AnalogDegree")) <= 30) && (asNumber(getValueForScene("Scene_Setter_", "_AnalogDegree")) >= 0)) || ((asNumber(getValueForScene("Scene_Setter_", "_AnalogDegree")) <= 360) && (asNumber(getValueForScene("Scene_Setter_", "_AnalogDegree")) >= 330))))
							{
								actor.setActorValue("AttackDirection?", "R");
							}
							else if(((asNumber(getValueForScene("Scene_Setter_", "_AnalogDegree")) <= 330) && (asNumber(getValueForScene("Scene_Setter_", "_AnalogDegree")) >= 300)))
							{
								actor.setActorValue("AttackDirection?", "RU");
							}
							else if(((asNumber(getValueForScene("Scene_Setter_", "_AnalogDegree")) <= 300) && (asNumber(getValueForScene("Scene_Setter_", "_AnalogDegree")) >= 240)))
							{
								actor.setActorValue("AttackDirection?", "U");
							}
							else if(((asNumber(getValueForScene("Scene_Setter_", "_AnalogDegree")) <= 240) && (asNumber(getValueForScene("Scene_Setter_", "_AnalogDegree")) >= 210)))
							{
								actor.setActorValue("AttackDirection?", "LU");
							}
							else if(((asNumber(getValueForScene("Scene_Setter_", "_AnalogDegree")) <= 210) && (asNumber(getValueForScene("Scene_Setter_", "_AnalogDegree")) >= 150)))
							{
								actor.setActorValue("AttackDirection?", "L");
							}
							else if(((asNumber(getValueForScene("Scene_Setter_", "_AnalogDegree")) <= 150) && (asNumber(getValueForScene("Scene_Setter_", "_AnalogDegree")) >= 120)))
							{
								actor.setActorValue("AttackDirection?", "LD");
							}
							else if(((asNumber(getValueForScene("Scene_Setter_", "_AnalogDegree")) <= 120) && (asNumber(getValueForScene("Scene_Setter_", "_AnalogDegree")) >= 60)))
							{
								actor.setActorValue("AttackDirection?", "D");
							}
							else if(((asNumber(getValueForScene("Scene_Setter_", "_AnalogDegree")) <= 60) && (asNumber(getValueForScene("Scene_Setter_", "_AnalogDegree")) >= 30)))
							{
								actor.setActorValue("AttackDirection?", "RD");
							}
						}
						/* "" */ if(isKeyDown("Attack"))
						{
							if(!((actor.getActorValue("FirstSpawn?") : Bool)))
							{
								if(!((actor.getActorValue("Attacking?") : Bool)))
								{
									actor.setActorValue("Attacking?", true);
									actor.setActorValue("Walk", false);
									_AttackModeNumber = 0;
									_AttackMode = true;
									_Sword.moveToTop();
									playSound(getSound(133));
									/* "Attack" */ if((actor.getActorValue("AttackDirection?") == "R"))
									{
										actor.applyImpulseInDirection(0, _AttackPushForce);
										_Sword.spinTo(-30, 0, Linear.easeNone);
										_Sword.spinTo(110, 0.14, Elastic.easeInOut);
										createRecycledActor(getActorType(9), (actor.getX() + 25), (actor.getY() + -5), Script.FRONT);
										getLastCreatedActor().setAngle(Utils.RAD * (randomInt(-8, 8)));
										createRecycledActor(getActorType(15), (actor.getX() + 23), (actor.getY() + 1), Script.FRONT);
										if(((Engine.engine.getGameAttribute("WhichSword") : String) == "Mage Wand"))
										{
											for(index0 in 0...2)
											{
												createRecycledActor(getActorType(96), (actor.getXCenter() - 8), (actor.getYCenter() - 8), Script.FRONT);
												getLastCreatedActor().setVelocity(randomInt(-30, 30), 70);
											}
										}
										if(((Engine.engine.getGameAttribute("WhichSword") : String) == "Slayer"))
										{
											for(index0 in 0...2)
											{
												createRecycledActor(getActorType(98), (actor.getXCenter() - 8), (actor.getYCenter() - 8), Script.FRONT);
												getLastCreatedActor().setVelocity(randomInt(-30, 30), 70);
											}
										}
										if(((Engine.engine.getGameAttribute("WhichSword") : String) == "Goldes"))
										{
											for(index0 in 0...3)
											{
												createRecycledActor(getActorType(100), (actor.getXCenter() - 12), (actor.getYCenter() - 12), Script.FRONT);
												getLastCreatedActor().setVelocity(randomInt(-90, 90), 70);
											}
										}
									}
									else if((actor.getActorValue("AttackDirection?") == "RU"))
									{
										actor.applyImpulseInDirection(-45, _AttackPushForce);
										_Sword.spinTo(-40, 0, Linear.easeNone);
										_Sword.spinTo(80, 0.14, Elastic.easeInOut);
										createRecycledActor(getActorType(9), (actor.getX() + 19), (actor.getY() + -25), Script.FRONT);
										getLastCreatedActor().setAngle(Utils.RAD * ((-45 + randomInt(-8, 8))));
										createRecycledActor(getActorType(19), (actor.getX() + 12), (actor.getY() + -17), Script.FRONT);
										getLastCreatedActor().setAnimation("2");
										if(((Engine.engine.getGameAttribute("WhichSword") : String) == "Mage Wand"))
										{
											for(index0 in 0...2)
											{
												createRecycledActor(getActorType(96), (actor.getXCenter() - 8), (actor.getYCenter() - 8), Script.FRONT);
												getLastCreatedActor().setVelocity((-45 + randomInt(-30, 30)), 70);
											}
										}
										if(((Engine.engine.getGameAttribute("WhichSword") : String) == "Slayer"))
										{
											for(index0 in 0...2)
											{
												createRecycledActor(getActorType(98), (actor.getXCenter() - 8), (actor.getYCenter() - 8), Script.FRONT);
												getLastCreatedActor().setVelocity((-45 + randomInt(-30, 30)), 70);
											}
										}
										if(((Engine.engine.getGameAttribute("WhichSword") : String) == "Goldes"))
										{
											for(index0 in 0...3)
											{
												createRecycledActor(getActorType(100), (actor.getXCenter() - 12), (actor.getYCenter() - 12), Script.FRONT);
												getLastCreatedActor().setVelocity((-45 + randomInt(-90, 90)), 70);
											}
										}
									}
									else if((actor.getActorValue("AttackDirection?") == "RD"))
									{
										actor.applyImpulseInDirection(45, _AttackPushForce);
										_Sword.spinTo(50, 0, Linear.easeNone);
										_Sword.spinTo(180, 0.14, Elastic.easeInOut);
										createRecycledActor(getActorType(9), (actor.getX() + 19), (actor.getY() + 18), Script.FRONT);
										getLastCreatedActor().setAngle(Utils.RAD * ((45 + randomInt(-8, 8))));
										createRecycledActor(getActorType(19), (actor.getX() + 12), (actor.getY() + 18), Script.FRONT);
										if(((Engine.engine.getGameAttribute("WhichSword") : String) == "Mage Wand"))
										{
											for(index0 in 0...2)
											{
												createRecycledActor(getActorType(96), (actor.getXCenter() - 8), (actor.getYCenter() - 8), Script.FRONT);
												getLastCreatedActor().setVelocity((45 + randomInt(-30, 30)), 70);
											}
										}
										if(((Engine.engine.getGameAttribute("WhichSword") : String) == "Slayer"))
										{
											for(index0 in 0...2)
											{
												createRecycledActor(getActorType(98), (actor.getXCenter() - 8), (actor.getYCenter() - 8), Script.FRONT);
												getLastCreatedActor().setVelocity((45 + randomInt(-30, 30)), 70);
											}
										}
										if(((Engine.engine.getGameAttribute("WhichSword") : String) == "Goldes"))
										{
											for(index0 in 0...3)
											{
												createRecycledActor(getActorType(100), (actor.getXCenter() - 12), (actor.getYCenter() - 12), Script.FRONT);
												getLastCreatedActor().setVelocity((45 + randomInt(-90, 90)), 70);
											}
										}
									}
									else if((actor.getActorValue("AttackDirection?") == "L"))
									{
										actor.applyImpulseInDirection(180, _AttackPushForce);
										_Sword.spinTo(30, 0, Linear.easeNone);
										_Sword.spinTo(-110, 0.14, Elastic.easeInOut);
										createRecycledActor(getActorType(9), (actor.getX() + -26), (actor.getY() + -5), Script.FRONT);
										getLastCreatedActor().setAngle(Utils.RAD * (randomInt(-8, 8)));
										getLastCreatedActor().growTo(-100/100, 100/100, 0, Linear.easeNone);
										createRecycledActor(getActorType(15), (actor.getX() + -22), (actor.getY() + 1), Script.FRONT);
										if(((Engine.engine.getGameAttribute("WhichSword") : String) == "Mage Wand"))
										{
											for(index0 in 0...2)
											{
												createRecycledActor(getActorType(96), (actor.getXCenter() - 8), (actor.getYCenter() - 8), Script.FRONT);
												getLastCreatedActor().setVelocity((180 + randomInt(-30, 30)), 70);
											}
										}
										if(((Engine.engine.getGameAttribute("WhichSword") : String) == "Slayer"))
										{
											for(index0 in 0...2)
											{
												createRecycledActor(getActorType(98), (actor.getXCenter() - 8), (actor.getYCenter() - 8), Script.FRONT);
												getLastCreatedActor().setVelocity((180 + randomInt(-30, 30)), 70);
											}
										}
										if(((Engine.engine.getGameAttribute("WhichSword") : String) == "Goldes"))
										{
											for(index0 in 0...3)
											{
												createRecycledActor(getActorType(100), (actor.getXCenter() - 12), (actor.getYCenter() - 12), Script.FRONT);
												getLastCreatedActor().setVelocity((180 + randomInt(-90, 90)), 70);
											}
										}
									}
									else if((actor.getActorValue("AttackDirection?") == "LU"))
									{
										actor.applyImpulseInDirection(-135, _AttackPushForce);
										_Sword.spinTo(40, 0, Linear.easeNone);
										_Sword.spinTo(-80, 0.14, Elastic.easeInOut);
										createRecycledActor(getActorType(9), (actor.getX() + -19), (actor.getY() + -25), Script.FRONT);
										getLastCreatedActor().setAngle(Utils.RAD * ((-135 + randomInt(-8, 8))));
										createRecycledActor(getActorType(19), (actor.getX() + -23), (actor.getY() + -17), Script.FRONT);
										if(((Engine.engine.getGameAttribute("WhichSword") : String) == "Mage Wand"))
										{
											for(index0 in 0...2)
											{
												createRecycledActor(getActorType(96), (actor.getXCenter() - 8), (actor.getYCenter() - 8), Script.FRONT);
												getLastCreatedActor().setVelocity((-135 + randomInt(-30, 30)), 70);
											}
										}
										if(((Engine.engine.getGameAttribute("WhichSword") : String) == "Slayer"))
										{
											for(index0 in 0...2)
											{
												createRecycledActor(getActorType(98), (actor.getXCenter() - 8), (actor.getYCenter() - 8), Script.FRONT);
												getLastCreatedActor().setVelocity((-135 + randomInt(-30, 30)), 70);
											}
										}
										if(((Engine.engine.getGameAttribute("WhichSword") : String) == "Goldes"))
										{
											for(index0 in 0...3)
											{
												createRecycledActor(getActorType(100), (actor.getXCenter() - 12), (actor.getYCenter() - 12), Script.FRONT);
												getLastCreatedActor().setVelocity((-135 + randomInt(-90, 90)), 70);
											}
										}
									}
									else if((actor.getActorValue("AttackDirection?") == "LD"))
									{
										actor.applyImpulseInDirection(135, _AttackPushForce);
										_Sword.spinTo(-50, 0, Linear.easeNone);
										_Sword.spinTo(-180, 0.14, Elastic.easeInOut);
										createRecycledActor(getActorType(9), (actor.getX() + -19), (actor.getY() + 18), Script.FRONT);
										getLastCreatedActor().setAngle(Utils.RAD * ((135 + randomInt(-8, 8))));
										createRecycledActor(getActorType(19), (actor.getX() + -23), (actor.getY() + 18), Script.FRONT);
										getLastCreatedActor().setAnimation("2");
										if(((Engine.engine.getGameAttribute("WhichSword") : String) == "Mage Wand"))
										{
											for(index0 in 0...2)
											{
												createRecycledActor(getActorType(96), (actor.getXCenter() - 8), (actor.getYCenter() - 8), Script.FRONT);
												getLastCreatedActor().setVelocity((135 + randomInt(-30, 30)), 70);
											}
										}
										if(((Engine.engine.getGameAttribute("WhichSword") : String) == "Slayer"))
										{
											for(index0 in 0...2)
											{
												createRecycledActor(getActorType(98), (actor.getXCenter() - 8), (actor.getYCenter() - 8), Script.FRONT);
												getLastCreatedActor().setVelocity((135 + randomInt(-30, 30)), 70);
											}
										}
										if(((Engine.engine.getGameAttribute("WhichSword") : String) == "Goldes"))
										{
											for(index0 in 0...3)
											{
												createRecycledActor(getActorType(100), (actor.getXCenter() - 12), (actor.getYCenter() - 12), Script.FRONT);
												getLastCreatedActor().setVelocity((135 + randomInt(-90, 90)), 70);
											}
										}
									}
									else if((actor.getActorValue("AttackDirection?") == "U"))
									{
										actor.applyImpulseInDirection(-90, _AttackPushForce);
										if((actor.getActorValue("FacingRight?") : Bool))
										{
											_Sword.spinTo(-40, 0, Linear.easeNone);
											_Sword.spinTo(80, 0.14, Elastic.easeInOut);
										}
										else
										{
											_Sword.spinTo(40, 0, Linear.easeNone);
											_Sword.spinTo(-80, 0.14, Elastic.easeInOut);
										}
										createRecycledActor(getActorType(9), (actor.getX() + 0), (actor.getY() + -26), Script.FRONT);
										getLastCreatedActor().setAngle(Utils.RAD * ((-90 + randomInt(-8, 8))));
										createRecycledActor(getActorType(17), (actor.getX() + -2), (actor.getY() + -16), Script.FRONT);
										if(((Engine.engine.getGameAttribute("WhichSword") : String) == "Mage Wand"))
										{
											for(index0 in 0...2)
											{
												createRecycledActor(getActorType(96), (actor.getXCenter() - 8), (actor.getYCenter() - 8), Script.FRONT);
												getLastCreatedActor().setVelocity((-90 + randomInt(-30, 30)), 70);
											}
										}
										if(((Engine.engine.getGameAttribute("WhichSword") : String) == "Slayer"))
										{
											for(index0 in 0...2)
											{
												createRecycledActor(getActorType(98), (actor.getXCenter() - 8), (actor.getYCenter() - 8), Script.FRONT);
												getLastCreatedActor().setVelocity((-90 + randomInt(-30, 30)), 70);
											}
										}
										if(((Engine.engine.getGameAttribute("WhichSword") : String) == "Goldes"))
										{
											for(index0 in 0...3)
											{
												createRecycledActor(getActorType(100), (actor.getXCenter() - 12), (actor.getYCenter() - 12), Script.FRONT);
												getLastCreatedActor().setVelocity((-90 + randomInt(-90, 90)), 70);
											}
										}
									}
									else if((actor.getActorValue("AttackDirection?") == "D"))
									{
										actor.applyImpulseInDirection(90, _AttackPushForce);
										if((actor.getActorValue("FacingRight?") : Bool))
										{
											_Sword.spinTo(-90, 0, Linear.easeNone);
											_Sword.spinTo(-230, 0.14, Elastic.easeInOut);
										}
										else
										{
											_Sword.spinTo(90, 0, Linear.easeNone);
											_Sword.spinTo(230, 0.14, Elastic.easeInOut);
										}
										createRecycledActor(getActorType(9), (actor.getX() + 0), (actor.getY() + 23), Script.FRONT);
										getLastCreatedActor().setAngle(Utils.RAD * ((90 + randomInt(-8, 8))));
										createRecycledActor(getActorType(17), (actor.getX() + -2), (actor.getY() + 27), Script.FRONT);
										if(((Engine.engine.getGameAttribute("WhichSword") : String) == "Mage Wand"))
										{
											for(index0 in 0...2)
											{
												createRecycledActor(getActorType(96), (actor.getXCenter() - 8), (actor.getYCenter() - 8), Script.FRONT);
												getLastCreatedActor().setVelocity((90 + randomInt(-30, 30)), 70);
											}
										}
										if(((Engine.engine.getGameAttribute("WhichSword") : String) == "Slayer"))
										{
											for(index0 in 0...2)
											{
												createRecycledActor(getActorType(98), (actor.getXCenter() - 8), (actor.getYCenter() - 8), Script.FRONT);
												getLastCreatedActor().setVelocity((90 + randomInt(-30, 30)), 70);
											}
										}
										if(((Engine.engine.getGameAttribute("WhichSword") : String) == "Goldes"))
										{
											for(index0 in 0...3)
											{
												createRecycledActor(getActorType(100), (actor.getXCenter() - 12), (actor.getYCenter() - 12), Script.FRONT);
												getLastCreatedActor().setVelocity((90 + randomInt(-90, 90)), 70);
											}
										}
									}
									/* "" */ actor.setAnimation("Idle");
									/* "" */ if(((Engine.engine.getGameAttribute("WhichSword") : String) == "Basic"))
									{
										runLater(1000 * 0.2, function(timeTask:TimedTask):Void
										{
											actor.setActorValue("Attacking?", false);
										}, actor);
									}
									else if(((Engine.engine.getGameAttribute("WhichSword") : String) == "Knights Claymore"))
									{
										runLater(1000 * 0.2, function(timeTask:TimedTask):Void
										{
											actor.setActorValue("Attacking?", false);
										}, actor);
									}
									else if(((Engine.engine.getGameAttribute("WhichSword") : String) == "Hammerhead"))
									{
										runLater(1000 * 0.25, function(timeTask:TimedTask):Void
										{
											actor.setActorValue("Attacking?", false);
										}, actor);
									}
									else if(((Engine.engine.getGameAttribute("WhichSword") : String) == "Mage Wand"))
									{
										runLater(1000 * 0.3, function(timeTask:TimedTask):Void
										{
											actor.setActorValue("Attacking?", false);
										}, actor);
									}
									else if(((Engine.engine.getGameAttribute("WhichSword") : String) == "Slayer"))
									{
										runLater(1000 * 0.16, function(timeTask:TimedTask):Void
										{
											actor.setActorValue("Attacking?", false);
										}, actor);
									}
									else
									{
										runLater(1000 * 0.15, function(timeTask:TimedTask):Void
										{
											actor.setActorValue("Attacking?", false);
										}, actor);
									}
								}
							}
						}
						/* "When Off - make effect." */ if(_AttackMode)
						{
							_AttackModeNumber = (_AttackModeNumber + 1);
							if((_AttackModeNumber >= 400))
							{
								/* "" */ _Sword.moveToBottom();
								_AttackMode = false;
							}
						}
					}
				}
			}
		});
		
	}
	
	override public function forwardMessage(msg:String)
	{
		
	}
}