package scripts;

import com.stencyl.graphics.G;
import com.stencyl.graphics.BitmapWrapper;

import com.stencyl.behavior.Script;
import com.stencyl.behavior.Script.*;
import com.stencyl.behavior.ActorScript;
import com.stencyl.behavior.SceneScript;
import com.stencyl.behavior.TimedTask;

import com.stencyl.models.Actor;
import com.stencyl.models.GameModel;
import com.stencyl.models.actor.Animation;
import com.stencyl.models.actor.ActorType;
import com.stencyl.models.actor.Collision;
import com.stencyl.models.actor.Group;
import com.stencyl.models.Scene;
import com.stencyl.models.Sound;
import com.stencyl.models.Region;
import com.stencyl.models.Font;
import com.stencyl.models.Joystick;

import com.stencyl.Engine;
import com.stencyl.Input;
import com.stencyl.Key;
import com.stencyl.utils.Utils;

import openfl.ui.Mouse;
import openfl.display.Graphics;
import openfl.display.BlendMode;
import openfl.display.BitmapData;
import openfl.display.Bitmap;
import openfl.events.Event;
import openfl.events.KeyboardEvent;
import openfl.events.TouchEvent;
import openfl.net.URLLoader;

import box2D.common.math.B2Vec2;
import box2D.dynamics.B2Body;
import box2D.dynamics.B2Fixture;
import box2D.dynamics.joints.B2Joint;

import motion.Actuate;
import motion.easing.Back;
import motion.easing.Cubic;
import motion.easing.Elastic;
import motion.easing.Expo;
import motion.easing.Linear;
import motion.easing.Quad;
import motion.easing.Quart;
import motion.easing.Quint;
import motion.easing.Sine;

import com.stencyl.graphics.shaders.BasicShader;
import com.stencyl.graphics.shaders.GrayscaleShader;
import com.stencyl.graphics.shaders.SepiaShader;
import com.stencyl.graphics.shaders.InvertShader;
import com.stencyl.graphics.shaders.GrainShader;
import com.stencyl.graphics.shaders.ExternalShader;
import com.stencyl.graphics.shaders.InlineShader;
import com.stencyl.graphics.shaders.BlurShader;
import com.stencyl.graphics.shaders.SharpenShader;
import com.stencyl.graphics.shaders.ScanlineShader;
import com.stencyl.graphics.shaders.CSBShader;
import com.stencyl.graphics.shaders.HueShader;
import com.stencyl.graphics.shaders.TintShader;
import com.stencyl.graphics.shaders.BloomShader;



class Design_89_89_RandomEnemySpawner extends ActorScript
{
	public var _CheckedAlready:Bool;
	public var _RNG:Float;
	public var _ForceSpawnWhichEnemy:Float;
	
	
	public function new(dummy:Int, actor:Actor, dummy2:Engine)
	{
		super(actor);
		nameMap.set("Actor", "actor");
		nameMap.set("Checked Already?", "_CheckedAlready");
		_CheckedAlready = false;
		nameMap.set("RNG", "_RNG");
		_RNG = 0.0;
		nameMap.set("ForceSpawnWhichEnemy?", "_ForceSpawnWhichEnemy");
		_ForceSpawnWhichEnemy = 0.0;
		
	}
	
	override public function init()
	{
		
		/* ======================== When Creating ========================= */
		runPeriodically(1000 * 0.3, function(timeTask:TimedTask):Void
		{
			for(actorInGroup in cast(getActorGroup(0), Group).list)
			{
				if(actorInGroup != null && !actorInGroup.dead && !actorInGroup.recycled){
					if(((actor.getXCenter() <= (actorInGroup.getXCenter() + 100)) && ((actor.getXCenter() >= (actorInGroup.getXCenter() - 100)) && ((actor.getYCenter() <= (actorInGroup.getYCenter() + 100)) && (actor.getYCenter() >= (actorInGroup.getYCenter() - 100))))))
					{
						if(!(_CheckedAlready))
						{
							_CheckedAlready = true;
							if((_ForceSpawnWhichEnemy == 0))
							{
								if(((Engine.engine.getGameAttribute("Difficulty") : Float) <= 2))
								{
									_RNG = randomInt(1, 10);
								}
								else
								{
									_RNG = randomInt(5, 10);
								}
								if((_RNG >= 5))
								{
									if(((Engine.engine.getGameAttribute("Difficulty") : Float) == 0))
									{
										_RNG = randomInt(1, 2);
										createRecycledActorOnLayer(getActorType(37), (actor.getXCenter() + randomInt(-16, 16)), (actor.getYCenter() + randomInt(-16, 16)), engine.getLayerByName("Player"));
										getLastCreatedActor().shout("_customEvent_" + "RandomSpawn");
									}
									else if((((Engine.engine.getGameAttribute("Difficulty") : Float) == 1) || ((Engine.engine.getGameAttribute("Difficulty") : Float) == 2)))
									{
										_RNG = randomInt(1, 2);
										if((_RNG == 1))
										{
											createRecycledActorOnLayer(getActorType(37), (actor.getXCenter() + randomInt(-16, 16)), (actor.getYCenter() + randomInt(-16, 16)), engine.getLayerByName("Player"));
											getLastCreatedActor().shout("_customEvent_" + "RandomSpawn");
										}
										else
										{
											createRecycledActorOnLayer(getActorType(106), (actor.getXCenter() + randomInt(-16, 16)), (actor.getYCenter() + randomInt(-16, 16)), engine.getLayerByName("Player"));
											getLastCreatedActor().shout("_customEvent_" + "RandomSpawn");
										}
									}
									else if(((Engine.engine.getGameAttribute("Difficulty") : Float) == 3))
									{
										_RNG = randomInt(1, 2);
										if((_RNG == 1))
										{
											createRecycledActorOnLayer(getActorType(106), (actor.getXCenter() + randomInt(-16, 16)), (actor.getYCenter() + randomInt(-16, 16)), engine.getLayerByName("Player"));
											getLastCreatedActor().shout("_customEvent_" + "RandomSpawn");
										}
										else
										{
											createRecycledActorOnLayer(getActorType(112), (actor.getXCenter() + randomInt(-16, 16)), (actor.getYCenter() + randomInt(-16, 16)), engine.getLayerByName("Player"));
											getLastCreatedActor().shout("_customEvent_" + "RandomSpawn");
										}
									}
									else
									{
										_RNG = randomInt(1, 3);
										if((_RNG == 1))
										{
											createRecycledActorOnLayer(getActorType(116), (actor.getXCenter() + randomInt(-16, 16)), (actor.getYCenter() + randomInt(-16, 16)), engine.getLayerByName("Player"));
											getLastCreatedActor().shout("_customEvent_" + "RandomSpawn");
										}
										else if((_RNG == 2))
										{
											createRecycledActorOnLayer(getActorType(106), (actor.getXCenter() + randomInt(-16, 16)), (actor.getYCenter() + randomInt(-16, 16)), engine.getLayerByName("Player"));
											getLastCreatedActor().shout("_customEvent_" + "RandomSpawn");
										}
										else
										{
											createRecycledActorOnLayer(getActorType(112), (actor.getXCenter() + randomInt(-16, 16)), (actor.getYCenter() + randomInt(-16, 16)), engine.getLayerByName("Player"));
											getLastCreatedActor().shout("_customEvent_" + "RandomSpawn");
										}
									}
								}
							}
							else
							{
								if((_ForceSpawnWhichEnemy == 1))
								{
									createRecycledActorOnLayer(getActorType(37), (actor.getXCenter() + randomInt(-5, 5)), (actor.getYCenter() + randomInt(-5, 5)), engine.getLayerByName("Player"));
									getLastCreatedActor().shout("_customEvent_" + "RandomSpawn");
								}
								else if((_ForceSpawnWhichEnemy == 2))
								{
									createRecycledActorOnLayer(getActorType(116), (actor.getXCenter() + randomInt(-5, 5)), (actor.getYCenter() + randomInt(-5, 5)), engine.getLayerByName("Player"));
									getLastCreatedActor().shout("_customEvent_" + "RandomSpawn");
								}
								else if((_ForceSpawnWhichEnemy == 3))
								{
									createRecycledActorOnLayer(getActorType(106), (actor.getXCenter() + randomInt(-5, 5)), (actor.getYCenter() + randomInt(-5, 5)), engine.getLayerByName("Player"));
									getLastCreatedActor().shout("_customEvent_" + "RandomSpawn");
								}
								else if((_ForceSpawnWhichEnemy == 4))
								{
									createRecycledActorOnLayer(getActorType(112), (actor.getXCenter() + randomInt(-5, 5)), (actor.getYCenter() + randomInt(-5, 5)), engine.getLayerByName("Player"));
									getLastCreatedActor().shout("_customEvent_" + "RandomSpawn");
								}
							}
						}
					}
				}
			}
		}, actor);
		
	}
	
	override public function forwardMessage(msg:String)
	{
		
	}
}